Natur EnemyCastBar

----
== Description: ==

Shows Debuffs (e.g. Sheep timers), Casts, Gains, Stuns, DoTs, BossTimers, Cooldowns, Diminishing Returns by lovely colored CastBars - Peace :D
Supports 'target' and 'focus'. Recognizes unknown spell casts, stops and delays!

=> Use "/necb" or the minimap icon to call the menue.

----
== Features (see "/necb help" for commands): ==

* Greatly improved AddOn with regard to garbage creation and CPU usage (version 8.3.7+; compare 8.3.7 with 7.9.8 yourself ;-) )
* Options may be set through a GUI matching the game's design. They are outsourced into a separate AddOn which is loaded on demand.
* Complete control of five shared profiles to fastly load/save and copy your settings!
* Offers a CounterStrike-like sound system that plays several sounds for killing blow events!
* Even unknown spell casts will trigger a bar, thanks to the new WoW 2.x API. Delays and CastStops are detected, too!
* Detects Debuffs/Buffs which return a duration and adapts CastBars to it!
* CastBars are even updated if Debuffs/Buffs are renewed. NECB checks for Resists/Misses, reads stack numbers and applied Debuffs for optimum results.
* Addon splitted into separated load on demand modules
* Automatic RaidSpell broadcasts through AddOns channel! (Users with a latency more than 500ms won't broadcast!)
* The CastBars will be pulled together if there is one bar deleted between others. (If CastBars last longer than 1 second.)
* CastBars will be sorted by color
* CastBar types may be separated into different movable frames!
* Afflictions/ (Spell)Debuffs implemented! This shows you how long "Shackle Undead" or "Polymorph" last!
* Class specific Diminishing Return timers which are only displayed for the class that can use this spell. The DeBuff duration IS recalculated by this timer!
* Detects almost every Stun and triggers a global stun diminishing return timer
* Icons to the left of the CastBars!
* CastBars watch your DoTs!
* Separated FPS Bar updated every frame and a latency bar
* Combopoints are taken into account for many spells
* You see some(!) spell cooldowns and detected cooldowns are stored into a dynamic database for all spells around you. The cooldown is displayed once you target the player/mob and cleared if you change targets.
* The Addon unregisters all Events if it is disabled or if the user gets a loading screen to minimize CPU load!
* Checks the version of group- and guildmembers and also has a button to whisper all users with old versions of NECB to update!
* You may trigger CastBars on your Party/RaidMembers screens. They have to toggle this feature on and receive your input via ".countmin", ".countsec" or ".repeat"
* CastBars with a total time >= 20 seconds will Flash if they reached the last 20% AND their time left is smaller than 10 seconds.
* All Fading/ Flashing of CastBars and the collapse animation of the options frame are FPS independent until the framerate drops below 5(fps).
* You may disable single(!) spells and save/load your selection ('SHIFT + RightClick' feature + see '/necb help')
* A checkbox to disable CastBars for 'gains' (like HoTs or 'Blink') separately.
* A checkbox to flip over the CastBars' order.
* The CastBar's width can be modified!
* You may customize the CastBar Colors!
* A Checkbox to enable 'global Mob outs'. If this one is enabled 'Mob outs' (which are 'Polymorph', 'Shackle Undead' etc.) will trigger a castbar even if the affected mob is NOT your current target.
* A slider to set the space between the CastBars!
* A slider to chose how many CastBars are displayed at once
* Afflictions/Gains which fade off will have their bars deleted! (Even if you don't target your enemy anymore.)
* Raidboss Debuffs supported! E.g. Vaelastrasz (BA), Razorgore (Conflagration), (Shadow of) Ebonroc, Geddon (Living Bomb), (Delusions of) Jin'do...
* A minimap button (movable/ hideable)
* A fullreset-button
* Settings will be saved per character
* Mainly the german client is supported
* Many new Spells added to the database regularly
* Channel parser for NECB's broadcasts
* Info box about the LUA5.1 Garbage Collector status!
* And more...

----
== Supportet spells: ==

* All supported spells are listed in NECB's checkbox tooltips ;-)

----
== These are not bugs: ==

* Spells won't trigger CastBars in many cases if you are not near enough for them to appear in your combatlog (e.g. Chromaggus). Use "/necb setrange cmax" or "necb setrange allmax" to increase the range.
* Spell cooldowns: Only spells with a castime or "gains" work. And no, I won't add more spell-checks to support those spells. (Too many complications :/ )
* If Mobs with a Debuff have the same name, it is (mostly) enough to have one Mob's debuff (or death) fade to clear the bar even without a target!
* If someone does not inflict your current target, but has debuffed a Mob with the name name, a bar will appear
* Conclusion: Expect strange bar behaviors if there are mobs with the same name :D That lies mostly in the nature of the combatlog!
* It works best if the same known debuffs are only casted on one mob if there are more mobs with the same name in combatlog-range ;-)
* Remember, some combatlog-messages (and with it the castbar clear or popup) only appear if you are very close to your enemy! (E.g. desheep.)

----
== Credits: ==

* I carried on the great work the original author >> Limited << did and I want to credit him and all others who helped with this addon!
* (If I have missed some names please tell me.)

----
== Support: ==

* http://www.curse-gaming.com/en/files/details/2786/natur-enemycastbar/
* http://www.digital-joker.de/cgi-bin/yabb2/YaBB.pl?num=1145309545

----
== Author(s): ==

The original author (Limited):

* Miranda on Al'Akir (EU)
* But please, don't ask me for support while im in game!
* If you want to thank me however, feel free :)
* http://misc.trustedadmin.net/carnival/forums/index.php

New/Modified versions (Naturfreund):

* All listed 'Natur' versions were done by - Naturfreund - (EU DE Tirion)
* New versions are available from http://www.curse-gaming.com/en/files/details/2786/natur-enemycastbar/

Most Bossmods support for Azeroth Instanzes has been provided by Funkydude!

----
== Important: ==

* Some bosses require to have them targetted to trigger PvE CastBars (or to unlock other castbars) on engage!
* (BWL: Firemaw, Ebonroc, Flamegor; AQ40: Three Bugs, Ouro, Huhuran, Twins, C'Thun; Naxxramas: Gluth, Maexxna, Loatheb)
* Read the above part "These are not bugs" ;-)
* Read the changelog carefully, especially if new features are presented!
* Use '/necb help' or the menue's HelpButton! (Did you know that 'Shift + RightClick' disables a single Spell/ CastBar?)


----
== Versions: ==

26.09.07 '''Natur EnemyCastBar 8.6.0'' | Localizations: China, Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
-------------------------------------------------------------------
* Added "Bloodlust" (Shaman) gain and cooldown to PvP module. (Disable with Shift + Rightclick or with "/necb disable Bloodlust") (Requested by Sunmark)
-------------------------------------------------------------------
* Removed "Crystalcore Sentinel" (The Eye) from beeing a trigger mob for the "Void Reaver Trash" bar. (Thanks to deepvoice)
* Added a bar for "Kael'thas Sunstrider Trash" (The Eye) (translated for enEN, frFR, deDE only!). (Thanks to deepvoice)
-------------------------------------------------------------------
* Added respawn timer for "Naj'entus Trash" and "Akama Trash" (Black Temple) (translated for enEN, frFR, deDE only!). (Thanks to Cicero71)
-------------------------------------------------------------------
* Updated translation of settings for zhTW and zhCN clients. (Thanks to iCeSun)
-------------------------------------------------------------------
* Fixed icon of "Prayer of Mending" and fixed this spell for frFR clients. (Thanks to Tony1004)
* Removed Debuff flag stacks=true, because there is no special routine needed anymore since blizz fixed the problem with patch 2.2!


12.09.07 '''Natur EnemyCastBar 8.5.7'' | Localizations: China, Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
-------------------------------------------------------------------
* New Feature: Heal Filter for Casts! Only displays a castbar if it is a healing cast (PvP Module). (Requested by a121)
-------------------------------------------------------------------
* New Feature: If a group member is afflicted by a "Mob out" CC skill, the name will be shadowed blue (uses color of raid afflictions - customizable). (Inspired by VIB)
* + These bars will at first display name and then mob (exactly like raid afflictions).
-------------------------------------------------------------------
* Added "Premeditation" (Rogue) to PvP gains (self buffs). (Requested by Leper)
* Added "Master of Subtlety" (Rogue) to PvP gains (other players + sound warning). (Requested by Leper)
-------------------------------------------------------------------
* Changed "Scare Beast" to only last 10 seconds in PvP. (Might not work with modified duration but at least it is flagged now.)
* Updated the icon texture of "Blade Flurry". (Thanks to obeah)
* Changed sound for critical PvP gains of your opponent back to the thorns sound and deleted scream.wav from the package. (Requested by hillkicker)
* + Search for "--play sound warning" in "CECB_PvPModule\CECB_PvPModule.lua" to modify the sound.
* Changed sequence "spellname (stack) - target" of Dots to "target - spellname (stack)". (Requested by hillkicker)
-------------------------------------------------------------------
* Updated zhCN and zhTW localizations. (Thanks to iCeSun)
* Fixed an error with asian localization of PvE Module. (Thanks to iCeSun)
* Fixed an error when dragging the latency bar. (Thanks to iCeSun)
* Fixed a minor problem in the menue when addon is disabled.
* Fixed possible "delay" text in spellname of poisons.
* Fixed overwritten poison levels if poisons had a stack counter.


22.08.07 '''Natur EnemyCastBar 8.5.2'' | Localizations: China, Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
-------------------------------------------------------------------
* New soundfile added: "/necb lol" will play a bigRoflmao! Enjoy...
* Changed soundfile for spell warnings (PvP) from 'thorns' sound to a human scream! (Thanks to MJL for a hint)
-------------------------------------------------------------------
* New Spell flag added (PvP Module): special="getbuff" instead of special=true additionally gathers Buff duration from buff slots.
* + Fixes "Slice and Dice" duration problem and offers a solution to add other self-buffs with variable duration!
-------------------------------------------------------------------
* New Spell flag added (PvP Module): cdclass="CLASS" only triggers a cooldown for the specified CLASS.
* + Fixes "Heroism" CD which is only displayed for 'Shaman' classed players now. (Requested by NPC_Mika)
* + Fixes "Misdirection" CD to only be triggered for Hunters now.
-------------------------------------------------------------------
* Changed "Hammer of Wrath" (Paladin): reduced casttime and cooldown by 0.5 seconds.
* Changed "Holy Vengeance" (Paladin) duration from 12 to 15 seconds.
-------------------------------------------------------------------
* Changed "'Mob outs' w/o target -> only!" setting: Won't disable spells only displayed to the player's class anymore!
* + Setting has been moved to the top and is beeing displayed as "reduce" now!
* + Tooltips of debuff checkboxes have been slightly enhanced!
* + + Hint: Only spells in white color are the active ones ;-)
-------------------------------------------------------------------
* Updated localization of NECB's menue for zhCN. (Thanks to iCeSun)
-------------------------------------------------------------------
* Fixed stack counters of self applied spells which count down instead of up (e.g. Stormstrike). (Thanks to Rhynox for a hint)


05.08.07 '''Natur EnemyCastBar 8.4.8'' | Localizations: China, Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
-------------------------------------------------------------------
* Added new setting to disable normal debuffs, which were not able to be disabled otherwise, before.
* + "'Mob outs' w/o target -> only!"
-------------------------------------------------------------------
* Changed "Mend Pet" to be always displayed when casted by yourself (like "Feed Pet"). (Requested by erwinmeier)
* Changed "Slice and Dice" so it will also be triggered if used by the character. (Requested by Noximus, WanderingFox and others)
* Added "Misdirection" cooldown. Will be displayed for everyone who gains it (caster & target).
* Updated zhTW translation of PvE Module. (Thanks to DeepVoice)


24.07.07 '''Natur EnemyCastBar 8.4.5'' | Localizations: China, Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
-------------------------------------------------------------------
* Check 'Load outdated Addons' if you use this version with WoW2.1! Toc has been set to WoW2.2 already.
-------------------------------------------------------------------
* NECB is ready for (PTRs and) Patch 2.2!!!
* + Adapted to new FramePoint System introduced by Blizzard (screwed bar placement completely)!
* + + Flawless transition of your castbar positions into the new system.
* + + Now the position of Bars behaves little different than before when scaling. (Fits better imho.)
* + Larger Scales won't make the castbar text and counter transform into "..." anymore.
* + Reduced PvP duration for capped skills from 12 to 10 seconds.
* + Duration of "Blind" has been reduced from 10 to 8 seconds.
-------------------------------------------------------------------
* New client language supported: zhCN! (Thanks to iCeSun (wowui.cn, prefered) and digmouse)
* + Now all clients around the world are beeing supported by NECB!
* + Still need many outland instance names/ mobs to be translated (zhCN, koKR and esES)
-------------------------------------------------------------------
* Added Respawn timer for Area Mobs of Leotheras (SSC) and renamed faulty Karathress timer to "MixedRespawn". (Many thanks for help to DeepVoice and my guild Morituri, Tirion EU!)
* Added zhTW client support for some respawn timers in SSC. (Thanks to DeepVoice)
* Added "Misdirection" (Hunter) to PvP gains.
-------------------------------------------------------------------
* Changed time until Instance name is checked from 5 to 10 secs to always load respawn timers (I guess).
-------------------------------------------------------------------
* Fixed a stupid error in line 450 of CECB_Debuffs.lua for Crusader Strike Pallies! (Big thanks to nate6138 and Xiras' hint!)


15.07.07 '''Natur EnemyCastBar 8.3.9'' | Localizations: Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
-------------------------------------------------------------------
* Added "Prayer of Mending" (Priest) Gain to PvP Module. (Requested by Arbor)
* Added "Explosive Trap Effect" (Hunter) to Debuffs (own DoTs).
* + Please tell me if this Trap Effect is not beeing detected if casted by yourself! Tell me the correct name of the DoT (with or without the 'effect' part?) then, please.
* Changed "Stormstrike" to be a Vulnerability (own category) and will be visible to ALL classes now. (Thanks to AgathoN668)
* Changed "Lifebloom" so it will not be deleted on fade events (dispells) anymore! Fixes incorrectly deleted bars. (Thanks to Theetjuh)
* + Lifebloom should also display the remaining duration of your own cast by adding a second, colored spark to the castbar now!
* + Lifebloom stack counter will always update with the last application of the Buff. Do not wonder when your stack counter drops from '3' to '1' when another Druid casts it.
* Changed "Feed Pet": Bar updates on recast and will always(!) been displayed now. (Requested by doxxx and others)
* + Fades won't be recognized anymore by most clients (because skill name inherits no 'effect' part and therefore differs from the Buffs name).
-------------------------------------------------------------------
* Added Trash RespawnTimers for "Morogrim Tidewalker" and "Fathom-Lord Karathress" (SerpentShrine Cavern).
* + I do NOT know if the link of trash mobs to the Bosses is correct. Please tell me any errors.
* + If you have any timers for me (TrashMob names, linked to which boss and respawns times) let me know.
* + There are still many names and translations missing for all clients but enUS and deDE!
* Removed "Coilfang Shatterer" from beeing a trigger mob for LurkerTrash (to prevent this timer after Tidewalker, SSC).
-------------------------------------------------------------------
* Many new instances (e.g. Karazhan, SSC, Magtheridon, Gruul) work with zhTW clients now! (Done by DeepVoice - Thanks!)
-------------------------------------------------------------------
* Fixed 'Heal-Filter' setting to only filter gains but not normal casts!
* Fixed possible cropped text with "/necb (g)versions".
-------------------------------------------------------------------
* Blizzard's change to the API with Patch 2.2: "Bug Fixes: Fixed unnecessary chopping of FontString contents when scaled."
* + Naturfreund says: "This would have saved me alot of work! Won't undo my changes/ workarounds now!".


06.07.07 '''Natur EnemyCastBar 8.3.7'' | Localizations: Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
-------------------------------------------------------------------
-- FINAL performance IMPROVEMENTS! --------------------------------
-------------------------------------------------------------------
* Once again did final changes to reduce garbage memory (and CPU usage) - mostly Debuffs Module! (I learned much about which functions/ commands produce garbage and use CPU cycles.)
* Result a): From 7.9.8 to 8.3.7 garbage creation has been reduced by 95% roughly! CPU usage between these two versions has been reduced by 70% roughly.
* Result b): Highly improved engine for the special purpose of this AddOn. No general Libraries used which increase loading times significantly. :D
-------------------------------------------------------------------
* Hint: Delete folders of NECB before you update! Some file names have been changed this time, because of a new global parsing system! ==
* Request: It would still help me alot to receive copies of your clients 'globalstrings.lua' file (ONLY zhTW and esES).
* + It would also be enough for now if you PM me (at curse-gaming.com) a screenshot of any red 'TURN IT: ...' messages after you typed "/necb debug" (do again to DISABLE debug mode) (ONLY zhTW and esES messages).
* + + This insures that my new 'world' parsing system is working as intended on high performance with any supported client version. :D
-------------------------------------------------------------------
* New Setting to disable rank information in CastBars (PvP casts). (Requested by KnThrak)
* New Setting to disable any spell coming from your target, so that only spells from your focus are beeing displayed. (Requested by Vectom)
* New Setting to only display healing gains instead of all gains!
* + Removed info frame of 'engage protection'! (It is just confusing users and is not used for WoW2.0 instances anyway.)
-------------------------------------------------------------------
* Major changes done to NECB's handling of stacking spells: Stacking Spells should work with all clients now!
* + Since many parts of well tested old code have been changed, things might got screwed up, although I checked the new code parts over and over again.
* + Spell names that inherit something in brackets (e.g. "Mangle (Bear)") will be shown without the part in brackets now.
-------------------------------------------------------------------
* Improved update system of Debuffs casted by yourself for stacking spells.
* + That prevents a short flickering of stacking and self cast Debuff bars when you updated the Debuff and shortly after the not yet updated Debuff slot was parsed! (Understood?^^)
-------------------------------------------------------------------
* Improved handling of PvE database if you enter known instances!
* + If you die and release your spirit then PvE database won't be flushed anymore -> no garbage memory creation!
* + + "/necb gettimer" now also works if you are a ghost.
-------------------------------------------------------------------
* Improved table usage for every check if Debuffs have been resisted/evaded etc. and if the duration of debuffs is modified by a rank-flag (e.g. Frostbolt, Polymorph etc.)!
* Improved code parts of Debuffs main module: Outsourced local function that produced high amount of garbage memory!
* Improved table usage for any broadcast of NECB!
* + Much less garbage creation for these events!
-------------------------------------------------------------------
* Improved last part of event registration: Unregisters more events if not needed with chosen settings.
* + This is the case if you disable all modules (3 events)/ disable Debuff Module + Gains (4 events)/ disable Debuffs module (2 events)
-------------------------------------------------------------------
* Improved compatibility of combatlog parsing: One and the same algorithm for all client languages!
* + Localized code patterns have been deleted and replaced by one 'world' file: Delete your folders if you update NECB ;-)
* + Should fix missing 'fade' detection with koKR and fixes possible problems with other languages!
-------------------------------------------------------------------
* Improved: One less combatlog pattern is parsed if no Boss Debuff Bars (on players) are loaded.
-------------------------------------------------------------------
* Improved: CECB_SELF1 ("You") and CECB_SELF2 ("you") are automatically created out of globalstrings now.
* + Might fix wrong localizations. (CECB_SELF2 does not work for all clients because of combatlog patterns, but do not mind.)
-------------------------------------------------------------------
* Improved: The output update rate of slash commands "/necb (g)versions" has been throttled to reduce creation of garbage memory dramatically for large amounts of users.
* + Minor improvements of the code itself to produce less garbage, but still generates some trash bytes. (Damn, if I only had the knowledge of ckknight ;p)
* Improved the whisper message of this feature to also display a download link now. Very old versions will inherit an "utterly outdated" part.
-------------------------------------------------------------------
* Added "Expose Weakness" (Rogue) to Debuffs (visible to Rogues only). (Requested by Prok)
* Added "Slice and Dice" (Rogue) Gain to PvP Module. (Fixed to 21 sec duration.)
* Changed Trash Respawn of the Curator (Karazhan) from 45 to 60 minutes. (Thanks to Zandy)
-------------------------------------------------------------------
* Changed MiniMap icon to be conform with other MiniMap buttons.
-------------------------------------------------------------------
* Fixed LUA error line 3936 (instantly triggered Cooldown bars if cast ends/ broken custom code if castbars end). (Thanks to bucketmasta, Nitrix, omegasnow, Kukulkan...)
* Fixed LUA error line 1144 (disabled NECB while called options window after relogin). (Thanks to Arrakis)
* Fixed Line Wrap for larger scales - hopefully. (Strange behaviour of WoW's API with larger scales.) (Thanks to nakomaru for the hint)
* Fixed multiple Rampage Bars. (Thanks to ZeroKnowledge)
* Fixed "Fear" so the bar will be deleted if the creature dies. (Thanks to lite)
* Fixed LUA errors for unknown client languages (zhCN). (Tell me if still any occur.)
* Many other small changes
* (Ps: I was choked with emotion when I finished this version and realized all the improvements with regard to memory garbage (and CPU time) since version 7.9.8! Oh well, just some 'simple' changes...)


29.06.07 '''Natur EnemyCastBar 8.2.5'' | Localizations: Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
=== Many bugfixes for new event distribution of NECB 8.1.0 ===
=== Further performance improvements and lot less garbage memory (by improved combatlog parser) ===

== New features: ==
-------------------------------------------------------------------
* New Slash Command "/necb gettimer" requests PvE Cooldowns/Respawn timers from other players. (Requested by Naugrim)
* + Removed "/necb bctimer"! That is only possible to use through the options menue now.
-------------------------------------------------------------------
* Improved handling of "Judgements" (Paladins) (requested by sag_ich_nicht):
* + "Crusader Strike" renews all Judgements on that Mob now, regardless whether you applied the Jugdements or not *hurray*.
* + + "Crusader Strike" will be checked for misses/dodges/.. messages.
* + "Crusader Strike" will be broadcasted to other Paladins in your group to renew their CastBars of that Mob!
-------------------------------------------------------------------
* Added Respawn Timers for Trash of "Al'ar", "Void Reaver" and "High Astromancer Solarian" (Tempest Keep) (esES, zhTW, koKR missing translation!).
* + These timers are considered beta stage! It is possible that Respawn timers might pop up at wrong places. Any feedback about the timers and mob names is appreciated.
-------------------------------------------------------------------
* Added: NECB's CastBars have a stack counter at their Icons! (New system to handle stacks! Any bugs?)
* + Customize the text color in colors menue of NECB (at the bottom; default is white). Changes are applied for new bars.
* + If Icons are enabled the stack counter in castbar label/text will be cleared!
-------------------------------------------------------------------
* Added "Howl of Terror" (Warlock) to Solo Debuffs. (Requested by Suspected)
* Added "Death Coil" (Warlock) to Solo Debuffs. (Requested by Suspected)

== Changes: ==
-------------------------------------------------------------------
* Changed "Fear" (Warlock) to be a "Mob out" spell now and removed 'Solo' spell flag. (Requested by Suspected)
-------------------------------------------------------------------
* Added spellflag "special" to PvP Module to handle these spells in a more general way: "Force of Nature", "Summon Water Elemental", "Shadowfiend", "Rampage"
* + These specials and "Victory Rush" will also be displayed now if PvP Module is loaded into memory but is disabled by the options.
-------------------------------------------------------------------
* Changed "/necb countmin, countsec, repeat, stopcount" to even work if NECB has been disabled completely (standby mode). (Requested by Boris)
-------------------------------------------------------------------
* Added a notification to "/necb parser" if disabled.
-------------------------------------------------------------------
* Increased the number of AddOns displayed in MiniMap Button Tooltip if CPU Profiling (/necb help) is enabled from 5 to 10.
* + Added percentage of total CPU Time used.
* + Produces less garbage memory.

== Improvements: (Should be complete now! Gargabe creation reduced down to 25% of NECB 8.1.0 and even better for pre 8.1.0!) ==
-------------------------------------------------------------------
* Improved parts of each module's parsing system for better performance and for far less garbage memory creation!
* + Optimized LUA command usage where possible!
* + Removed "Xyz begins to perform spell" pattern from PvP Module to increase performance of that parsing module by 15-20%.
* + + The above pattern was only used by 4 out of more than 200 Spells in database and therefor was a waste of CPU time!
-------------------------------------------------------------------
* Improved performance of bar update system: Castbar update rate is dynamically set by the bar duration now!
* + Performance gain is most noticable for long bar durations and high FPS systems.
* + + Between 10 seconds and 22 minutes the bars update between 66 and 0.5 FPS (lowest rate)
* + + CastBars are updated at screen refresh rate (your FPS) if duration left is less than 10 seconds!
* + FPS Bar updates with 10 FPS instead of screen refresh rate now.
-------------------------------------------------------------------
* Improved Event registration of PvP Events needed for MC/AQ/Naxxramas/Onyxia/BWL
* + Only creature events will be registered to detect spell casts if other PvP settings/Events (of players) have been disabled
-------------------------------------------------------------------
* Improved event registration of PvE events!
* + Also fixed line 293 error for asian clients. (Thanks to jusuya8!)
-------------------------------------------------------------------
* Improved input routine of "/necb countsec, countmin, repeat"
-------------------------------------------------------------------

== Fixes: ==
-------------------------------------------------------------------
* Translated settings and Respawn timers of SSC for esES clients. (Thanks to Yebanen and Asuea)
-------------------------------------------------------------------
* Fixed event distribution of Combatlog events (broken with NECB 8.1.0!):
* + Healing/ Buffing spell casts and their cooldowns are detected by Combatlog again!
* + Spell casts of creatures are detected by combatlog again.
* + Spell interruption of "Show Castbars w/o target" (PvP Module) works correctly again.
* + PvE Spells for two Bosses in Naxxramas fixed.
* + Performance estimation of settings has been adjusted.
-------------------------------------------------------------------
* Fixed a stupid bug that has broken the active hot spark (HoT system for multiple HoTs of the same name) when bar was falling down or pushed up!
* Fixed a stupid bug that has broken the manual broadcast of PvE cooldowns for non-deDE clients!
* Fixed a bug introduced with NECB 8.1.0 so that broadcasted "fades" (fading mob outs like Polymorph) have an effect again.
* Fixed a bug that prevented the display of new CastBars in very rare cases.
* Fixed typo in "Avenger's Shield" (PvP Module, enUS/enGB). (Thanks to MiniHunt)
* Other minor changes and fixes
-------------------------------------------------------------------
* Hint: PvE Module will automatically adapt PvP/Debuff settings and event registration internally if a known Instance has been detected.
* + Performance estimation will be adjusted internally, but some settings won't have an effect on performance in instances because of the above method.


18.06.07 '''Natur EnemyCastBar 8.1.0'' | Localizations: Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
== NECB is more lightweight now! But full functional! =============
-------------------------------------------------------------------
* New Feature: Estimated Power Consumption (CPU cycles + garbage creation) is indicated by a new bar placed into the options menue!
* + This is a rough estimation of the impact your settings have on NECB performance considering a standard situation in 25-man raids.
* + If you disabled PvE/Debuffs module you will see different calculations in different instances, because of internally loaded modules and registered events if required.
-------------------------------------------------------------------
* Improved combat log parser significantly: Precise distribution of events on parsing functions -> lot less checks!
* + Filtered resource hungry checks by adding fast prechecks: That reduces the hits of ressouce hungry checks dramatically!
* Improved performance of Debuff resisted/missed function -> lot less checks!
* Improved performance of NECB's control function (internal Event distribution) -> less checks!
* Improved: If you disabled Debuffs/PvP Module then Debuff/Gains/Casts events will only be registered for PvE if there is a concurrent flag in database -> lot less checks for Outland Instances if PvP/Debuffs modules disabled!
* Improved: NECB's Addon Channel Parser now has to be activated in the options menue, because it uses some script memory if in group/raid.
-------------------------------------------------------------------
* Ten Tips to reduce memory usage and to improve performance especially in raids (can be considered a ranking):
*  1) Disable "Show CastBars even w/o Target" setting, because it will also use a spell interrupt detection which is a real burner!
*  2) Disable Cooldowns! Update of cooldowns in datase will create lots of garbage and checks will be done for many spells in combatlog range!
*   --> Disable both of above 3) Disable Cooldowns AND "Show CastBars even w/o Target" to unregister combatlog parsing of spellcasts! This is an enormous performance hit in raids with many casters!
*  4) Disable PvP/Debuffs Module if you only need to see NECBs respawn timers in outland Instances!
*  5) Disable any Diminishing Return timers (two settings). This is additional code and another dynamic database (mostly used in real PvP environment!).
*  6) Disable Focus CastBars if you often have a focus target will improve performance a little.
*  7) Disable NECB's Addon Channel Parser if you do not need it. It will create some garbage if your group/raid does a lot of polymorph/banish or version requests.
*  8) Disable "Parse AddOn/Raid/PartyChat" setting if there are very many broadcasters or broadcasts in your raid/group (way more than one broadcast per second in average).
*  9) Don't play with an opened options window.
*  10) Keep your amount of CastBars as low as possible.
-------------------------------------------------------------------
* Added "Concussive Barrage" (Hunter) Debuff only visible to casting class. (Requested by Zyber)
* Added "Judgement of Justice" (Paladin) Debuff only visible to casting class. (Requested by Zor)
* Added "Enslave Demon" (Warlock) Debuff only visible to casting class. Flagged as beeing a "mob out" spell. (Requested by friend)
-------------------------------------------------------------------
* Changed/Improved: Unknown Icons of Spells not in NECB's database will have their smiling face icon replaced by a "?" icon.
-------------------------------------------------------------------
* Fixed too far away "T" and "F" Icons if "timer inside of castbars" has been disabled. (Thanks to bonsailucco)
* + Space is inserted until pvp/debuff focus and "T" icon settings have been disabled
* Fixed failed detection of missed/resisted Debuffs for zhTW clients.
* Fixed reset of FPS and latency bar position when changing bar modes (seperated mode - normal mode)
* Other minor improvements and fixes all over the code!


13.06.07 '''Natur EnemyCastBar 7.9.8'' | Localizations: Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
* New Feature: You are able to drill Cooldown bars to keep them visible even if targets are changes by simply RightClicking on them! (Requested by Soton)
* + As a grafical indication a thumbtack appears on the bar's left side.
-------------------------------------------------------------------
* New Feature: Killing Blow - Sound System! If you kill another player or a NPC/Mob which is worth Honor or Experience a special sound is beeing played!
* + If you kill another unit within 60 seconds the next sound level is reached which results in another sound beeing played. This will increase until you reach level 5 and hear a "Godlike!" sound!
* + New checkboxes have been added to customize the settings of this new feature.
-------------------------------------------------------------------
* Added "Hydross the Unstable" (Serpentshrine Cavern) respawn timers of trash mobs (missing mob names for esES, koKR, zhTW!). (Thanks to Azonia!)
* Added "The Lurker Below" (Serpentshrine Cavern) respawn timers of trash mobs (missing mob names for esES, koKR, zhTW!).
* Added "Feed Pet Effect" (Hunter Pet Buff) to PvP Module. (Please check translation: in some languages it is with/without 'Effect' part - not sure.) (Requested by Talz83)
* Added cooldown to "Heroism" (Shaman) in PvP Module. This will display a cooldown for every group member - better than nothing, isn't it? (Requested by Razieel)
* Added example of use to "custom.lua" in folder "CEnemyCastBar". If activated it displays a basic cooldown for "Psychic Scream" (not localized!). (Inspired by randomname)
-------------------------------------------------------------------
* Localized all additions of 7.9.0 for spanish clients! (Thanks to Asuea)
-------------------------------------------------------------------
* Changed: The Icon size is always fixed in its size! It does not depend on space between CastBars anymore.
* Changed: Maximum length added to bars has been reduced to +100 from +150.
* Changed: Maximum space between bars has been reduced to 25 from 30.
* Changed: Maximum scale of bars has been increased from 150% to 180%.
* Changed: Garbage Collection on any module loaded has been removed.
* Changed time waited for instance name (PvE Module) from 3 to 5 seconds. Sometimes loading times are longer than 3 secs if the (raid) instance is beeing entered the first time. If this problem appears again simply uncheck/check PvE checkbox to load timers!
* Other minor changes
-------------------------------------------------------------------
* Fixes not detected "Mend Pet" (and other Buffs) if it was your own pet. Added event "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" to detect any Buff your Pet (and theoretically your character) gains. (Thanks to Zladko and Talz83)
* Fixed translation of "High King Maulgar" (Gruuls Lair) for deDE client (because Blizz changed this name recently).
* Fixed translation of "Tidal Charm" and "Will of the Forsaken" for koKR client. (Thanks to jusuya8)
* Fixed possible info messages in the middle of the screen if a profile has been loaded.
* Fixed a problem with wrapped text of bar times for larger scales.


07.06.07 '''Natur EnemyCastBar 7.9.0'' | Localizations: Korea, Taiwan, England/US, Spain, France, Germany. (Use "/necb help" for INFO!)
* New language supported: SPAIN has arrived!
* + All aspects of the Addon have been translated into spanish language by Yebanen of 'Blind Guardians'! (Thanks for the great work!)
-------------------------------------------------------------------
* Added timer for heroic quest in Shattered Halls (missing debuff name: koKR, zhTW; missing boss name to clear: esES). (Thanks to Mestar)
* Added timer for Baron Run in Stratholme (missing debuff name: koKR, zhTW). (Thanks to Mestar)
-------------------------------------------------------------------
* Added "Blackout" (Shadow Priest) Debuff. (Requested by Symbio)
-------------------------------------------------------------------
* Added file "custom.lua" to main folder to allow custom code beeing executed after any bar runs out! (Requested by Xaviér)
* + Read further info inside of "custom.lua".
-------------------------------------------------------------------
* Fixed problem with not loaded function for koKR clients! (Thanks to jusuya8)
* Fixed line 646 error (casted Debuff without having a target/focus). (Thanks to Azonia!)
* Fixed line 4139 error (possibly missing variables of combatlog ranges). (Thanks to Kendorp!)


26.05.07 '''Natur EnemyCastBar 7.8.6'' | Localizations: Korea, Taiwan, England/US, France, Germany. (Use "/necb help" for INFO!)
* Fixed missing sync and message (1 min cooldown) when old versions have been notified through the whisper-button with "/necb gversions".
* Fixed line 271 error (concatenate with NIL ;P). (Thanks to feu)
* Fixed line 571 error (unkown API command ;p). (Thanks to omegasnow)


25.05.07 '''Natur EnemyCastBar 7.8.5'' | Localizations: Korea, Taiwan, England/US, France, Germany. (Use "/necb help" for INFO!)
* Hint: Increase your combatlog range with "/necb setrange" to increase the range of all player events! Then you will never miss any Buffs/Debuffs casted on other players (e.g. HoTs).
* + That does not work for creature events. Their range has been set to a fixed value by Blizzard.
-------------------------------------------------------------------
* Minor changes to the new Debuff system: Out of Raidgroups each change of your target's UnitAura is processed. In Raidgroups this will only be done once every 0.25 secs at most.
* + This results in castbars not updating instantly in some cases, but will throttle down the amount of processing time when fighting against raid-bosses.
* + Remember, NECB uses three ways to provide 'perfect' bars: 1) Combatlog, 2) When you press an action button and the spell has been used, 3) When the Debuffs/Buffs you applied change in any way on your target/focus. ONLY Part 3 is beeing affected by the above limitation ;-)
-------------------------------------------------------------------
* Added "Mend Pet" (Hunter) to PvP Module. (Requested by oo0o0)
-------------------------------------------------------------------
* Changed respawn timer of Magtheridon's trash from 1 to 2 hours. (Thanks to petsasj)
-------------------------------------------------------------------
* Removed message of PvE Module that the current instance is unkown by NECB and removed the 3sec CastBar until the instance name is checked. (Inspired by tehorc)
-------------------------------------------------------------------
* Fixed problems with Poisons (and maybe some others - changed some key code parts). (Thanks to Azonia)
* Fixed "Curse of tongues" for german clients. (Thanks to Xandriana)


22.05.07 '''Natur EnemyCastBar 7.8.3'' | Localizations: Korea, Taiwan, England/US, France, Germany. (Use "/necb help" for INFO!)
--- 25 Spells added! ----------------------------------------------
* New API extension of 'Unit(De)Buff' supported and greatly modified the Debuff-System:
* New Feature: NECB now gathers and compares your target's (and focus') Debuffs with NECB's running bars. (Thanks to doxxx for new API info)
* + This allows NECB to nearly detect every Debuff YOU applied to your target or focus! (Pet spells are not handled as your spells by the WoW API!)
* + + Even procs (e.g. Rogue poisons and much more) are renewed now!
* + + Debuffs are read on the fly if you change targets (which is great for AoE Debuffs after your target died).
* + + + The Bar's name adapts to your target/focus one if only one bar for this spell is allowed for multiple mobs!
* + + All this is completely independent of any combatlog message. There is NO range limitation (until you lose your target)!
* + But: The whole new system might not work if there are other players who apply the same debuff, therefore the old system is still used and the new system is an additional part. (Blizzards restrictions)
-------------------------------------------------------------------
* New Feature: Bars that match your target's name will have a "T" icon at their right. Might help when fighting against multiple mobs!
* + Added a checkbox (right menue part) to toggle this feature on/off.
-------------------------------------------------------------------
* New Feature: PvP Module will improve any healer's HoT experience!
* + HoT Bars have two sparks now: The HoT timer of your cast will be indicated by a green spark, HoTs from other players will be indicated by the normal spark.
-------------------------------------------------------------------
* New language supported: KOREA has arrived!
* + All aspects of the Addon have been translated into korean language by Juno! (Many, many thanks for the great work!!!)
-------------------------------------------------------------------
* Improved the "Show CastBars even w/o Target" feature! (Requested by warhau)
* + Casts from Group- or Raidmembers now always are checked by an accurate algorithm to determine if it is a hostile or friendly unit.
-------------------------------------------------------------------
* Improved: The MiniMap tooltip displays any Debuff/Buff of your target that delivers its time left (which are only the ones casted by you).
* + Easy to see how long your(!) buffs are lasting on your target now (e.g. Arcane Brilliance or Power Word: Fortitude).
-------------------------------------------------------------------
* Improved: Tooltip of the MiniMap button now uses new WoW 2.1.0 API to detect the exact memory used by NECB's modules! (Use "/necb gcinfo" to clear garbage to see the pure memory used.)
-------------------------------------------------------------------
* Improved: Tooltip of the MiniMap button now uses new WoW 2.1.0 API to detect the exact CPU time in seconds used by installed AddOns!
* + The five AddOns which use the most CPU cycles will be listed in NECB's MiniMap button tooltip. (Keep in mind that the visible tooltip creates garbage and uses CPU cycles which NECB is blamed for^^)
* Attention! You need to enable this feature for your client by typing "/necb cpu" in chat.
-------------------------------------------------------------------
* Improved the 'whisper' feature of "/necb (g)versions", to avoid the new whisper throttling introduced with patch 2.1.0! (Thanks to Alphonse for some tests)
* + NECB will now use its internal chat system to notify users to update.
* + After a notification has been done the feature is locked for one minute.
-------------------------------------------------------------------
* Improved "/necb disable [spell]" command to disable separate bar colors (same function as ALT + RightClick). (Inspired by holmvig)
* + These are the codes for all bar colors: "Bartype friendly", "Bartype hostile", "Bartype gainsfoe", "Bartype gainsfriend", "Bartype afflict", "Bartype stuns", "Bartype dots", "Bartype cooldown", "Bartype grey"
-------------------------------------------------------------------
* Improved: "Rampage" (Fury Warrior) will also be shown if used by the player character now. (Requested by Ixan and others before)
* (+ There is a known issue with Rampage if used by other players. That won't be changed because missing combatlog messages prevent an accurate timing anyway.)
-------------------------------------------------------------------
* PartyLeaders are allowed to play the 'jingles', too, now! (Requested by sag_ich_nicht)
-------------------------------------------------------------------
* Readded slash command "/necb setrange" to toggle between maximum and default combatlog ranges!
* + This only works for player events currently! These are almost any damage events you and your mates do to the mob.
* + Creature events ('Mob is afflicted by spell', 'Spell fades from mob') are still limited to 30 yards it seems.
-------------------------------------------------------------------
* New sound file added: "/necb mkill" plays the well known "M M M Monsterkill.." sound now. (Requires Leader/Assist)
-------------------------------------------------------------------
* Added "Entrapment", "Intimidation", "Counterattack", "Improved Wing Clip" and "Immolation Trap Effect" (Requested by BrknSoul) (Hunter) to Debuffs.
* Added "Improved Hamstring", "Deep Wound" DoT (Warrior) to Debuffs. ("Deep Wound" without 's' translation for frFR, zhTW required!)
* Added "Vengeance", "Vindication" and "Holy Vengeance" (Paladin) to Debuffs. Only visible to casting class.
* Added "Judgement of the Crusader", "Judgement of Wisdom" and "Judgement of Light" (Paladin) to Debuffs. Only visible to casting class.
* Added "Hemorrhage", "Deadly Poison", "Wound Poison" and "Mind-numbing Poison" (Rogue) to Debuffs. Only visible to casting class. All levels of poison supported.
* Added "Aftermath" and "Pyroclasm" (Warlock) to Debuffs.
* Added "Dazed" to Debuffs. (Remember: You are able to disable single spells with Shift + RightClick!)
* Added rank detection to "Rend" (Warrior) Debuff. (Thanks to LordDrago)
* Added rank detection to "Hammer of Justice" (Paladin) Debuff. (Thanks to Xager)
* Added rank detection to "Kidney Shot" (Rogue) Debuff. (Thanks to mazui)
* Added talent detection to "Chilled" (Mage) Debuff. (Thanks to Sanalia)
-------------------------------------------------------------------
* Added "Berserking" (Troll racial) to PvP Spells. (Thanks to Gattzu)
* Added "Blood Craze" and "Second Wind" (Warrior talent) to PvP Spells.
* Added "Blazing Speed" (Mage talent) to PvP Spells.
* Added "Backlash" (Warlock talent) to PvP Spells.
-------------------------------------------------------------------
* Changed cooldown of "Shadowstep" (Rogue) from 20s to 10s (WoW 2.1.0).
* Changed duration of "Barkskin" (Druid) from 15s to 12s (WoW 2.1.0).
* Changed "Rebirth" (Druid): casttime removed and added 'icasted' flag to have a more accurate cooldown detection.
* Changed "GuestQuarterRespawn" from 45 to 60 minutes. (Thanks to Hagar)
-------------------------------------------------------------------
* Changed setting of 'timer inside of castbars' to 'true' by default.
-------------------------------------------------------------------
* Fixed problems with some french localizations of Debuffs. (Thanks to Nilyn)
* Fixed "TheTopRespawn" respawn timer (Karazhan) for german client if a "Greater Fleshbeast" has been killed.
* Fixed a color error in "/necb parser" for version requests done by other players. (Thanks to Varda)
* Fixed a possible lua error if a Priest DoT that triggers the shadow vulnerability debuff was used by a shadow priest. (Thanks to Theik)
* Fixed: CD-Bars should be cleared correctly again after you change zones and lose your target.
* Other minor changes here and there


21.04.07 '''Natur EnemyCastBar 7.3.4'' | Localizations: Taiwan, England/US, France, Germany.
* New Feature: PROFILES may be saved/loaded through the new 'profile' button in NECB's menue! (Thanks to Artack of SW_Stats for some inspiration)
* + Simply chose one character and save a profile. If you do not enter anything (or clear the editbox), the name and realm will be inserted automatically!
* + Now you log into the character you want the profile to be applied and just load it - done!
* + Multiple profiles of one character possible through custom names! Have fun...
-------------------------------------------------------------------
* New Feature: Simply LeftClick on a Bar to copy "'BarLabel' mm:ss" into the editbox. (Requested by amadh)
-------------------------------------------------------------------
* New slash command "/necb bctimer" to broadcast any PvE cooldown/respawn timer to all your group/raid members! (Requested by Irion and amadh)
* + Added a button to the options menue that has the same function and toggles to enabled if broadcastable bars are available.
* + Not compatible with older versions of NECB: Bars won't be set to the right point of time left. UPDATE required!
-------------------------------------------------------------------
* Added "Stormstrike" (Shaman) to Debuffs only visible to characters with this skill. (Requested by Thanaroth)
* Added placeholder '%f' -> FocusName to be supported by NECB's 'countmin', 'countsec', 'stopcount' and 'chat'
-------------------------------------------------------------------
* Changed: Counterspell duration has been reduced from 10 to 8 seconds (for patch 2.1.0).
-------------------------------------------------------------------
* Improved Debuffs module slightly to make DoTs work in Duells (and possibly in other PvP situations).
* Improved Debuffs module to support changed curse durations in PvP (patch 2.1.0).
* Improved: "Arcane Protector" will delete a possible "GalleryRespawn" timer.
-------------------------------------------------------------------
* Removed "Spell Shade" (Karazhan) from beeing a Library3 trigger. Only "Sorcerous Shade" triggers the Netherspite trash timer now.
* Removed slash commands "/necb setrange allmax, cmax" because modified ranges are NOT supported by WoW clients anymore it seems! (Even PTR 2.1.0 does not.)
-------------------------------------------------------------------
* Fixed minor design problems with NECB's enable/disable feature
* Fixed: Increased the time NECB waits for the instance name from 2 to 3 seconds. Sometimes 2 seconds do not seem to be enough.


11.04.07 '''Natur EnemyCastBar 7.2.4'' | Localizations: Taiwan, England/US, France, Germany.
* New PvP spell flag: callspell={"SpellName", talentTab, talentNumber, checkValue}. More info in localized PvP LUAs. Used for "Healing Way" gain updates.
* + "Healing Wave" will update "Healing Way" if full talent points have been invested. (Requested by Illae)
-------------------------------------------------------------------
* Improved callspell Debuff flag to be compatible with spells that trigger a bar of their own. (Was a pain to code, hope it works right in real environment.)
* + "Shadow Word: Pain", "Vampiric Touch" and "Devouring Plague" renew "Shadow Vulnerability", too, if full talent points (5) invested! Tell me if more spells are missing (procs don't work!) :D (Requested by Raistlin1)
* + "target"/"focus" has to be selected to renew the bar
-------------------------------------------------------------------
* Added respawn timers for trash mobs of "Terestian Illhoof", "Netherspite" and "Prince Malchezaar" (Karazhan). (Thanks to Irion for his tip!)
* Added respawn timer for trash mobs of Magtheridon.
* Added "Overload" to PvE Debuffs (Karazhan, Arcane Watchman). (Spell's name for frFR and zhTW required!)
* Added Rank detection to "Fear" (Warlock).
-------------------------------------------------------------------
* Added "Hunter's Mark" to Debuffs (only visible to Hunters). (Requested by Centekhor)
* Added "Mind Flay" and "Shadow Word: Death" which will renew the "Shadow Vulnerability" bar now. (Thanks to funkydude)
* Added "Earth Elemental Totem" (Shaman) cooldown.
* Added "Heroism" (Shaman) to PvP spells.
-------------------------------------------------------------------
* Improved the tooltip of Debuffs checkbox: It will display the class in brackets for which the spell is only visible for if the flag has been set.
* Improved: Accidently overlapping Sound-Jingles (/necb bhill, western, xfiles) will be prevented by a cooldown of 10 seconds now.
* Improved: "/necb bhill" will play the sound for pre 7.1.6 versions, too, now.
-------------------------------------------------------------------
* Removed plevel and rankmod flags from "Polymorph: Pig" and "Polymorph: Turtle" because they do not have a rank that can be selected. (Many thanks to Mestar!)
* Removed the obsolete 'aZone' PvE Debuff flag from the Debuff core engine.
* Removed 'sclass' flag from Debuff database, because 'spellDR' contains this information now.
* Changed 'callspell' in Debuff section! 'tskill' has been merged into it to allow an improved usage (see above).
-------------------------------------------------------------------
* Fixed a bug that deleted DoT-type bars if spell fades. DoT bars should never fade on combat log fade events, it might be a same named DoT applied by another player.
* Fixed stack counters of '0' or '1' in case of some PvP gains (with cgain flag).
* Undocumented changes with latest WoW patches: CombatLogRange settings will have no effect! Seems to be fixed at a long range for players and a medium range for creatures currently. :O


03.04.07 '''Natur EnemyCastBar 7.1.6'' | Localizations: Taiwan, England/US, France, Germany.
* Improved: Color selection has been increased by four new (shadow and text) colors: 1) own class debuffs, 2) bars with your name, 3) PvE debuffs and 4) unknown PvP spells.
* Improved: "Seduction" duration now considers talent points invested into "Improved Succubus". (Requested by Tricker)
-------------------------------------------------------------------
* Added respawn timers for trash mobs of Curator and Shade of Aran (Karazhan). (Thanks to Zurom for some details)
* + ATTENTION: It is adviced to kill the patrolling "Arcane Protector" instead of the "Arcane Watchman" (Library) to always trigger the right (and accurate) timer.
* Added "Flame Wreath" Debuff for Shade of Aran (Karazhan).
-------------------------------------------------------------------
* Added "Scare Beast" (Hunter) to solo Debuffs. (Requested by sr1030nx)
* Added "Turn Undead" (Paladin) to solo Debuffs. (Requested by sr1030nx)
* Added "Seal of Vengeance" (Paladin) to Debuffs only visible by Paladins. (Requested by sr1030nx)
-------------------------------------------------------------------
* Added two new soundfiles and CHANGED "/necb wipe" into three new commands (/necb bhill, western, xfiles). (Requested by Sorikaga^^)
-------------------------------------------------------------------
* Changed the icon of "Shadow vulnerability". (Thanks to funkydude)
* Removed: Absorb (SPELLLOGABSORBSELFOTHER) won't prevent a renew of Debuff Bars anymore. Hope this is correct in any case.
* Fixed a possible error (line 388) reported by omegasnow, Kukulkan, JohnnyBlade, Pahonix.
-------------------------------------------------------------------
* Fixed some errors in BWL and Naxxramas for zhTW client. (Thanks to seireimai and JCG)
* Fixed a problem with stacking debuffs (like sunder armor) for zhTW client. (Many thanks to jyzjl for some info!)
* Fixed: "Faerie Fire (Feral)" will call "Faerie Fire" for zhTW client (because of missing brackets in zhTW client).


25.03.07 '''Natur EnemyCastBar 7.1.0'' | Localizations: Taiwan, England/US, France, Germany.
- NECB charms Warlocks now! - Also considers spell ranks now! -----
* Improved: Every Warlock curse will only trigger a bar if casted by yourself, and if you change your curse on the same mob (with the same name), NECB will change its bar, too.
-------------------------------------------------------------------
* Improved (requested by angelblack): Spell ranks are considered for the following spells:
* "Frostbolt", "Fireball" and "Polymorph" (Mage), "Shackle Undead" (Priest), "Banish" (Warlock), "Sap" (Rogue), "Entangling Roots" and "Hibernate" (Druid)
* + In some (rare) cases the default duration might be applied. (NECB still uses a complex combination of combat log and local events!)
-------------------------------------------------------------------
* Added "Curse of Weakness", "Curse of Recklessness", "Curse of the Elements", and "Curse of Shadow" to DoTs section. (Requested by Jackalantern)
-------------------------------------------------------------------
* Improved: Debuffs (yellow bars) that are castable by your character's class will receive a bright green text now.
-------------------------------------------------------------------
* Fixed: Cooldowns and DiminishingReturn timers will be cleared on zone shifts now and minor code improvement. (Thanks to Denorius)
* Fixed: "Starfire Stun" (Druid) does no longer trigger the 'Stun DR' timer. (Thanks to Tradix)
* Fixed line '3401 error' caused by a spelling mistake (non-deDE clients).
-------------------------------------------------------------------
* Translated many spells/settings for zhTW localization. (Thanks alot to CuteMiyu!)


16.03.07 '''Natur EnemyCastBar 7.0.4'' | Localizations: Taiwan, England/US, France, Germany.
-------------------------------------------------------------------
* New Feature: Added a latency bar (optional). (The FPS-Bar has been reduced to the length of the latency-bar.) (Requested by malorye)
-------------------------------------------------------------------
* Added "Force of Nature" (Druid) timer for selfcasts (PvP gain). (Requested by graywolfe)
* Added "The Big Bad Wolf" and "Ghostly Philanthropist" for Karazhan (PvE) to clear the respawn timers on boss' death. Timer labels have been localized a bit (deDE).
* Added "Silencing Shot" (Hunter) to solo Debuffs. (Requested by Syrela)
* Added: "Mind Blast" will renew the "Shadow Vulnerability" timer if full talent points are invested into "Shadow Weaving". (Requested by Dispel)
-------------------------------------------------------------------
* Improved: "Mind Soothe" got a 'fragile' flag -> multiple bars allowed and displayed even without targetted (optional). (Requested by Munksgaard)
* Improved: Unknown slash commands are part of NECB's error message now.
* Improved the tchange sub-routine to be able to apply a change of duration multiple times without getting a bigger temporary database.
-------------------------------------------------------------------
* Fixed a possible bug at the tchange sub-routine and applied other minor changes
* Fixed "Feral Charge" by renaming it to "Feral Charge Effect". (Thanks to Kolakhan)


07.03.07 '''Natur EnemyCastBar 7.0.1'' | Localizations: Taiwan, England/US, France, Germany.
-------------------------------------------------------------------
* Improved: "Frostbolt" duration now relies on the player's level. (Thanks to Naem)
* Improved: "Frostbolt" and "Cone of Cold" take invested talent points ('Permafrost') of the local player into account.
-------------------------------------------------------------------
* Changed: "Victory Rush" duration adapted to patch 2.0.10 (15 to 20 secs).
-------------------------------------------------------------------
* Fixed PvE: Respawn timers for Gruul and Karazahn won't fade any longer. (Also fixes problems with detected spell interruptions vs Bosses and their broadcasts.)


05.03.07 '''Natur EnemyCastBar 7.0.0'' | Localizations: Taiwan, England/US, France, Germany.
-------------------------------------------------------------------
* Compatibility issues with SW_FixLogStrings (SW_Stats) solved:
* + NECB creates its combat log patterns on entering world now (delayed creation).
-------------------------------------------------------------------
* New Feature/Setting: Some PvP Skills will trigger a sound warning if enabled. See tooltip for a list of spells. (Idea by fision112)
-------------------------------------------------------------------
* Added "Vampiric Embrace" (Priest) Debuff only visible to Priests. (Requested by specr1)
-------------------------------------------------------------------
* Added "Brittle Bones" Debuff for Karazhan (PvE Spell).
* Added respawn timer of Karazhan trash mobs before Attumen, Moroes, Maiden, The Crone (zhTW missing). (Big thanks to Fettehupe)
* Added "Magic Ward" (Krosh Firehand's gain) for Gruul's Lair (PvE Spell). (Thanks to Tzitzimime)
* Added trash mob respawn timer for Gruul's Lair.
-------------------------------------------------------------------
* Improved PvE Spell flag "tchange" to make changes permanent until player logs out or reloads UI. (Used to disable obsolete respawn cooldowns.)
-------------------------------------------------------------------
* Fixed 'checktarget' flag for PvE Spells
* Fixed wrong PvE Message in some cases
* Minor reorganization of settings layout


23.02.07 '''Natur EnemyCastBar 6.9.4''' | Localizations: Taiwan, England/US, France, Germany.
-------------------------------------------------------------------
* New Feature: Spell Rank of PvP Spells will now be displayed inside of CastBars (behind spell name). (Requested by notsoeasy)
-------------------------------------------------------------------
* New Feature/Setting: The fillmode of Debuffs, Gains and Dots can be toggled now. (Requested by redforty)
-------------------------------------------------------------------
* Feature changed/improved: CastBars of your focus target can now be toggled for PvP and Debuffs separately. (Requested by Affix)
-------------------------------------------------------------------
* Added "Shadowfiend" (Priest) timer for selfcasts (PvP gain). (Requested by Dagna)
-------------------------------------------------------------------
* Improved: "Demoralizing Shout" (Warrior) now considers talent points. (Thanks to Fettehupe)
* Improved: "Corruption" duration now relies on the player's level. (Thanks to Naem)
* Improved: CastBars of your focus target are updated/renewed now. (Thanks to Affix and Xystus)
* Improved: Cooldowns of your focus target are displayed with the spell cast now.
* + Cooldowns stored in database will still only be displayed for the targetted unit!
-------------------------------------------------------------------
* Fixed: "Soulstone Resurrection" won't trigger a cooldown for the one who 'gains' it.
* Fixed: If you enter an Arena the cooldown database will now be cleared properly. (Reported by Affix, thanks)
* Fixed: Spell DiminishingReturn timer will be cleared from database if the targetted unit is dead. (Thanks to Aliens)
* Fixed: The slider to set the number of castbars won't be hidden in seperate bars mode anymore if you disable/enable the addon.
* Fixed: Debuffs on your focus target are not beeing displayed any longer if you disable focus bars.
* Fixed: Cooldowns of Gains will be triggered with the spell simultaniously again.


09.02.07 '''Natur EnemyCastBar 6.8.8''' | Localizations: Taiwan, England/US, France, Germany.
-------------------------------------------------------------------
* Improved: Version requests now inherit a counter of how many clients have answered plus a usage ratio.
-------------------------------------------------------------------
* Improved ToolTips: Spells in ToolTips will now be sorted by alphabetic order. Disabled (grey) spells are put to the end of list.
* + Spells with class specific DR timers now display their concurrent class in brackets. Your class will be colored green, others red.
-------------------------------------------------------------------
* Added "Soulstone Resurrection" (Warlock) casttime and cooldown.
* Added "Impact" (Mage) stun to solo Debuffs. (Requested by Gendr)
* Added "Nether Protection" (Warlock talent proc) to PvP Spells/Gains. (Requested by ikzo)
* Added "Starfire Stun" (Druid talent proc) stun to solo Debuffs, and it shares the big stun timer (correct?). (Requested by Imabug)
* Added "Tidal Charm" (Trinket) stun to solo Debuffs without any DR timer. (Requested by Affix)
-------------------------------------------------------------------
* Changed: "/necb add, remove" have been renamed into "/necb disable, enable". I hope this is more intuitive.
-------------------------------------------------------------------
* Removed Cooldown of "Tranquility" (Druid) because a 'gain' message for all party members is triggered and not only a 'receivs heal' one. Wrongly assigned cooldowns were the result. (Thanks to Imabug)
-------------------------------------------------------------------
* Fixed: Mangle will now trigger a stuns bar and not a debuff bar anymore. (Thanks to Malak)
* Fixed: Disabled focus' bars setting will stay disabled after a reload now. (Thanks to Las for his report!)
* Fixed: "Cyclone" will trigger a DiminishingReturn timer for mobs now, too, if you are a Druid. (Thanks to sr1030nx)
-------------------------------------------------------------------
* Special greetings to 'Access' (eXistenZ guild) who passed me in Nagrand/Tirion/EU and then chatted with me until morning just because he loves this Addon... wow, that's a 'crazy groupie' :D
* This is the version that will soon be released on DVD by the german magazine PC PowerPlay


03.02.07 '''Natur EnemyCastBar 6.8.3''' | Localizations: Taiwan, England/US, France, Germany.
-------------------------------------------------------------------
* New Feature: Whenever "Victory Rush" (Warrior) is ready it will trigger a PvP gain timer for your character. (It is possible that it will be updated wrongly in some rare cases!).
* + This has been added because "Victory Rush" is no buff and you can not see any timer otherwise.
* Added "Summon Water Elemental" (Mage) timer for selfcasts (PvP gain). Same reason as above.
-------------------------------------------------------------------
* Improved: NECB now scans the HoTs of your current target if you cast/renew a HoT and adapts the stack counter! Very accurate system for druids/priests now :D
* + The last HoT bar (without any counter) will be cleared like in earlier versions if the debuff fades.
-------------------------------------------------------------------
* Improved: "Scorch" will update "Fire Vulnerability" if full talent points were invested into "Improved Scorch". (That's another coded exception :o) (Requested by DamnCold, thanks!)
-------------------------------------------------------------------
* Added "Mace Stun Effect" (Warrior/Rogue) to Debuffs. I decided to not trigger a DR Timer (same with Revenge Stun), although it has its own Diminishing Returns. (Requested by Wranor)
* Added "Consecration" (Paladin) to DoT Debuffs. (Requested by Naem)
* Added "Soothe Animal" (Druid) to Debuffs. (Requested by sr1030nx)
* Added "Dragon's Breath" (Mage) disoriented effect to Debuffs. (Requested by bomberb17)
* Added "Fireball" (Mage) DoT to Debuffs. (Requested by bomberb17)
* Added "Pyroblast" (Mage) DoT to Debuffs. (Requested by bomberb17)
* Added Cooldown to "Evocation" (Mage).
* Added Cooldown to "Feedback" (Priest).
-------------------------------------------------------------------
* Changed the Cooldown of "Blessing of Protection" (Paladin) from 300 to 60secs, because NECB will display the Cooldown of the target of this spell (who gained it).
* Changed some notifications and tooltips that have to do with PvE and Boss Debuffs. (Thanks to funkydude)
-------------------------------------------------------------------
* Fixed: German translation of "Mangle" corrected ('Fleddern' -> 'Zerfleddern'). Will be detected for deDE clients again now. (Thanks to Navarion)
* Fixed: German translation of "Intercept Stun" corrected.
* Fixed: "Freezing Trap Effect" considers talent points again after talent tree has been changed some patches ago. (Thanks to zodius)
* Fixed: In separated bars mode stacking Debuffs will now display the correct number of debuffs applied, in case a new bar was triggered.
* Fixed: Combatlog patterns for enUS/enGB, frFR and zhTW were broken for any buff/debuff removal (do not mix up with fade events) and have been fixed now by swapping positions of mob <-> spell. (Thanks to Funak for his report!)
* Fixed: Resists/Dodges/... of Debuffs with brackets (e.g. 'Fearie Fire (feral)', 'Mangle (bear)') now properly prevent the CastBar from beeing renewed. (Special thanks to kSashka for his report)


28.01.07 '''Natur EnemyCastBar 6.7.7''' | Localizations: Taiwan, England/US, France, Germany.
-------------------------------------------------------------------
* Added "Garrote - Silence" (Rogues) effect to Debuffs section. (Thanks to jamers and Capp)
* Added "Deadly Throw" (Rogues) to Debuffs section. (Thanks to Azonia)
* Added "Earth Shock" (Shamans) spell school blackout to Debuffs section.
* Added "Gift of the Naaru" (Draenei) HoT to PvP section.
* Added "War Stomp" (Tauren Racial) effect to Debuffs section. (Thanks to Tradix)
* Added "Arcane Torrent" (Blood Elves) silence effect to Debuffs section. (Thanks to Atsumori)
-------------------------------------------------------------------
* Changed texture of "Mangle" into the correct one. (Thanks to Drjeyjey3 and kSashka)
* Changed Cooldown of "Holy Shock" from 30 to 15 secs. (Thanks to archiv)
* Changed icon and duration of "Chilled".
-------------------------------------------------------------------
* Improved: Afflictions with brackets in their name now are renewed, too: 'Fearie Fire (feral)', 'Mangle (bear)' ... (Thanks for info to MinguzDew, admitchencsu and kSashka)
-------------------------------------------------------------------
* Removed any 'Conjure', 'Portal/Teleport' and 'Creates Poison' spell from PvP database.
-------------------------------------------------------------------
* Warning: The Sub-Addon 'SW_FixLogStrings' (shipped with SW_Stats) changes GLOBAL combatlog strings after NECB has been initialized and so might break some CastBars (known issue with frFR client)!


20.01.07 '''Natur EnemyCastBar 6.7.2''' | Localizations: Taiwan, England/US, France, Germany.
* New Setting: Place timer inside of CastBars and change the alignment of the CastBars text to 'left'. (Requested by Hack)
* NECB now uses an Icon instead of "(F)" to mark a Focus CastBar
* Disabled Spells will be displayed in grey color in options menue.

* Fixed "Unknown command entered!" message when another player broadcasted a "/necb (g)versions" request. (Thanks to Jenay and my wife 'Zeroluxa' for their report.)
* Fixed: Boss Debuffs do not depend on an enabled PvE Checkbox anymore. Initialization of Boss Debuffs was improved in some more ways.
* Fixed: While NECB initializes its PvE modules on entering an instance (the first time after a login) it should not produce any errors on PvE events anymore in this short phase (2 seconds). (Thanks for info to Jim-Bim)
* Fixed: Disabled PvE Spells will be disabled correctly for each Instance now.
* Some other minor code changes/improvements.


19.01.07 '''Natur EnemyCastBar 6.7.0''' | Localizations: Taiwan, England/US, France, Germany.
Advice: Delete your CEnemyCastBar folder, before you install this version because of removed/changed filesnames! This version's PvE code changed dramatically. Pls, report any LUA error of the PvE_Module ;-)
-------------------------------------------------------------------
* New Setting: Different Fonts may be applied to the CastBars by a new slider now. (Thanks for some fonts to SCT Addon)
-------------------------------------------------------------------
* Improved: Added known texture names, changed(!) and added some textures. (Thanks to ACE2 surfaces from andreasg)
-------------------------------------------------------------------
* New Feature: Options Tooltips of NECB now display all detected spells! (All Debuffs, PvE/Raid Spells and number of cooldowns/pvp spells)
* + PvE and Boss Debuffs change their tooltip if you enter an instance.
-------------------------------------------------------------------
* Improved: PvE Database has been revised: Only the spells and variables of the specific instance will be loaded! They are cleared if you leave the instance. *hurray*
* Also the PvE Functions now adapt to the concurrent instance and are cleared(!) if you leave the area :D (Better performance and completely modulized)
* + This makes PvE flag 'aZone' obsolete! Has been removed.
* + Removed 'custom_localization.lua' from PvE_Module.
* + Boss Debuffs have been internally moved into PvE section and are loaded/cleared for each instance seperately now.
-------------------------------------------------------------------
* New Feature: Setting to disable CastBars of 'Focus' Unit for all CastBar types that check your 'Focus'. Exception: Boss engages will always check 'focus' name. (Requested by Affix :D)
-------------------------------------------------------------------
* New Feature: Unit Spell Channeling is now detected by NECB, too! Works like other (unknown) spell casts supported some versions ago :D
* + Channeled CastBars are running in the opposite direction to clearly discriminate channeling vs. normal spell casts!
* + Now ALL spells and spell channeling - known and unknown - will be displayed.
* + Many (I hope all) points are considered: Stop display of gains if it is a channeled spell and reset if global pvp is enabled, behaviour of cooldowns with these spell type etc.
* + Search for "--uncomment below to change direction of castbar types" in CEnemyCastBar.lua to let other bar types run from right to left and remove "--" of the lines following.
-------------------------------------------------------------------
* Increased maximum time for "Movable Bars" from 2 to 5 minutes. (Click on this button fastly to increase the duration). Remember: With RightClick on the Button you delete all Bars.
* Converted Audio files into MP3 format to reduce download size.
* Removed almost every chat message for changed settings
* Changed range of setting for scaling to 50% - 150%. (Bloodygrey's request)
* Changed/Fixed time until the new "mob death with same name" routine will be canceled from 0.25 to 0.5 seconds. That should fix the rare problem of not cleared castbars on mob deaths.
* Improved: Cooldowns will be cleared if you enter a PvP Arena! (Thanks to Affix!)

* Changed german spell name of "Demoralizing Shout" for BC version. If you encounter any name changes of spells in other languages please let me know ;-)
* Changed "Mangle" (Druid) from 10 to 12 secs and "Pounce" from 2 to 3 secs duration. (Thanks to woowoowoo)
* Added "Lacerate" (Druid) Debuff only visible to Druids. (Thanks to woowoowoo)
* Removed any Mob Spells from PvP Section

* Fixed: Diminishing Returns are now properly cleared in seperated mode if mob dies
* Fixed: Spell interruptions/stops of unkown spells will now be handled correctly (e.g. they will be cleared).
* Fixed PvE Boss Gains displayed in black instead of 'gains' color.
* Other code changes/optimizations


10.01.07 '''Natur EnemyCastBar 6.5.5''' | Localizations: Taiwan, England/US, France, Germany.
Tipp: Do not forget "/necb help".
-------------------------------------------------------------------
* New Feature: If you switched your target to a casting Unit and did miss the cast start NECB will now trigger an exact castbar that displays the remaining duration! (Thanks to funkydude for this idea)
-------------------------------------------------------------------
* Improved: When a mob with the same name dies, but it was not 'your' mob, the CastBars won't be cleared in most cases.
* Improved: Every AnchorBar's exact center now stays into position if scale setting has been changed!
* Improved: Every changed slider setting will display all bars now! This is a good chance to disable the colors you do not want to see (with ALT + RightClick), because mouse input will stay enabled.
* ReAdded the checkbox to set the CastBars text size.
* Removed the throttle slider. I proclaim it useless and I did not like it at all.
* Removed the CastBreak checkbox. It was obsolete, because it will be set dynamically since 6.4.5.
-------------------------------------------------------------------
* Added a MiniMap Button for 'disabled status' of NECB.
* ALT + LeftClick on the MiniMap Button enables/disables the AddOn.
-------------------------------------------------------------------
* Added new Afflictions flag 'notdetected=true' for Debuffs that are not beeing detected by NECB's combat log parser!
* + Those Debuffs will only trigger a CastBar for the Caster!
* + "Distract" (Rogues) was added to Afflictions section as an example for the use of 'notdetected=true'. (Thanks to SinisterStrike)
* + + You have to target the Mob you want to Distract, otherwise NECB won't trigger a bar! There are the same problems as with "Flamestrike" AoE (s. 6.4.7 changelog).
-------------------------------------------------------------------
* Added new Afflictions flag 'spellbreaker=true' for Debuff Bars that shall only be triggered if a spell interruption of your target has been detected!
* + "Counterspell" (Mages), "Kick" (Rogues), "Shild Bash" and "Pummel" (Warrior) were added and use both, 'notdetected=true' and 'spellbreaker=true'.
* + + Coded a new detection that checks whether the target was really casting something (e.g. red bar found?). So these bars indicate a REAL spell school blackout! :D
-------------------------------------------------------------------
* Added support for NECB Communication in Arena Battlegrounds (untested).
-------------------------------------------------------------------
* Fixed a bug that appeared if players with a disabled NECB entered the gaming world.
* Fixed a bug with the new placeholder support (%t) for NECB's custom bars or "/necb chat". (Thanks to ZeroKnowledge)
* Fixed MiniMap Button trouble caused by 'MobileMinimapButtons' Addon! That Addon simply unregistered NECB's on drag catcher!
-------------------------------------------------------------------
* Known issue: MindControl casted by another player on Mobs does always trigger a player combat event, so NECB thinks that a player is afflicted and sets the timer to 12s! (Thanks to funkydude)
* + Workaround 1: If the MCed Unit is your target NECB will check if it is a player character.
* + Workaround 2: If you are in an instance but not in battlegrounds NECB will always assume you MCed a non player character.
-------------------------------------------------------------------
* + Patch 2.03 changes applied to "Tranquility" (Druid), "Divine Illumination" (Paladin), "Cloak of Shadows" and "Garrote" (Rogue), "Shadowfury" (Warlock)
* + Added Mage Pet Spell "Freeze" that will now trigger a "Frost Nova" bar (fr, tw missing).
* Added Rogue Spell "Shadowstep".
* Updated TOC for Patch 2.03

* Hint: Use "/necb setrange allmax" or "/necb setrange cmax" to increase your combatlog range which might be needed for NECB's debuff/buff renew system to work properly in case of long range spells!


04.01.07 '''Natur EnemyCastBar 6.4.7''' | Localizations: Taiwan, England/US, France, Germany.
* Improved updated castbars when debuffs/buffs are renewed:
* + Increased the time that NECB waits for misses/resists (for example "Holy Fire" sometimes needs 5x more time than melee spells to trigger a resist message :/ )
* + Added another check needed for german clients that catched unwanted patterns, too. (German combat strings are a pain compared to en, fr!)
* + One exceptional problem is the spell "Flamestrike", because it is an AoE DoT that is independent of your current target: Keep sure your Target is in impact range to receive a possible miss/resist message or selecet no target.
* + Another problem are spells that have a flying time until they hit their target (e.g. Frostbolt). These need around 0.2 - 1.4s to produce a resist/miss message. NECB now waits some more time based on the rough range to the target. For Frostbolt mages it is adviced to disable this spell in Raids if you notice a loss in performance.

* Added an additional cooldown bar for Razuvious (Naxxramas) if his Disruptive Shout is not beeing cast.

* Improved: If PvP and Debuff modules are disabled they won't be loaded until needed.

* Fixed a NIL error for AoE spells you casted without having something in target. (Thanks to Knifed)
* Fixed a missing variable name for french clients. (Thanks to rocodido)


01.01.07 '''Natur EnemyCastBar 6.4.5a''' | Localizations: Taiwan, England/US, France, Germany.
* Fixed an error message if something with the bar color generation has gone wrong. (Thanks to Vampyrr/Basia)


31.12.06 '''Natur EnemyCastBar 6.4.5''' | Localizations: Taiwan, England/US, France, Germany.
Hint: This version of NECB again has received some major code changes. This is a door for new bugs, so please test and report anything.
-------------------------------------------------------------------
New Feature: NECB now UPDATES Buffs and Debuffs YOU(!) cast on the target (e.g reSheep, reDoT...)! (Makes use of new Wow 2.0 "UNIT_SPELLCAST_SUCCEEDED" event!)
* + Nearly all cases have been taken into consideration, e.g. PvP CC's can't be renewed... (Remind this feature is some sort of trick/workaround for missing combatlog messages.)
* + Checks for resists/misses and many other non hitting events to prevent faulty updates. Even checks if mob is already afflicted by this debuff.
* + Even click casts work to update existing(!) castbars. (Pure click casts do not trigger new bars to prevent bar spam! Hint: NECB catches 'focus' target, too ;-))
* + Even catches the number of stacks and displays new bars with a stack counter (for stackable spells only, not for normal HoTs).
* + This makes "/necb cast" useless. Slash command removed.
* + The bar update function has been improved to work more properly in non separated mode.
* + If I missed to flag any PvP spells (Gains) for the update feature, please tell me. (Currently all HoTs + four other (cgain=true).)
-------------------------------------------------------------------
* NECB's 'countmin', 'countsec', 'stopcount' and 'chat' now support the following placeholders: (Thanks to Thavian for this idea.)
* + '%t' = TargetName, '%tt' = TargetofTargetName, '%c' = TargetClassName, '%g' = TargetRaidGroupNumber
* + Example: "/necb countmin 5 ReBuff %t in Group%g"
-------------------------------------------------------------------
* Improved: HoTs and 'multi' Debuffs (e.g. Taunt) won't have their their last castbar (without any stacks) cleared any earlier than full duration.
* Added Sunder Armor Debuff (only visible to warriors), since it will perfectly be renewed by your applications now. Devastate updates the Sunder timer (new Debuff database flag) :D
* Added Druid Rake Debuff (Thanks to fraserstanton)
-------------------------------------------------------------------
* Improved: Added new code to catch 'move on drag' and 'mouse clicks' both with the visible castbars only. No faux frames are generated anymore which reduces the number of used castbar frames by 50%!
* + Reduced CastBars Height to match the visible part exactly (removed 6 invisible pixels of height). Done minor design adjustments.
* Improved: CastBars and FPSBar positions are stored into NECB's saved variables now.
* + If Addon was disabled or failed to load on login, CastBar positions are still remembered by this change.
* + NECB will transfer your castbar frame points into the new system on the fly when your character logs in.
-------------------------------------------------------------------
* Improved code parts that have to do with NECB's old spell interrupt check! Much less checks fired by combat events.
-------------------------------------------------------------------
* Combat log search patterns are now created automatically by the clients (localized) GlobalStrings.lua. (zhTW needs to be tested).
-------------------------------------------------------------------

* Fixed an ugly bug that allowed the anchor bars to be moved after a relog. That also broke the "Disable Mouse" feature after relogin. (Thanks to Epicurean, Rithiur, Alarius for hints.)
* Minor fixes/improvements


26.12.06 '''Natur EnemyCastBar 6.3.5''' | Localizations: Taiwan, England/US, France, Germany.
Here it is, and you will get it: FOR FREE! You ask what is here and I say: "SEPARATED FRAMES!" Hurray...
-------------------------------------------------------------------
* New Feature/Option: SEPARATED FRAMES for EVERY Bar Type!
* +You may select from 1 to 6 Bars displayed for each(!) color; makes a total of 9 up to 54 Bars on screen! But you should not worry about the performance loss too much, because (read on below):
* +Bar update and Bar search algorithms have been optimized to achive maximum performance with separated frames feature enabled!
* +The color sort routine will be internally disabled if you enable this feature to further improve performance!
* +Be careful: For technical reasons the bar positions have to be reset if bar numbers are changed in separated mode. (Frames are virtually regenerated for each setting.)
-------------------------------------------------------------------
* NECB now differentiates between hostile and friendly gains (new color!). (Thanks to dariuslloyd for this idea.)
-------------------------------------------------------------------
* Debuffs that can be applied multiple times on the same target (e.g. Taunt) now STACK like HoTs do.
-------------------------------------------------------------------
* Revised the 'Disable Spell/Color' feature: New function: ALT + RightClick to disable a COLOR completely!
* +Removed "/necb load" and "/necb save" since disabled spells/colors are saved and loaded instantly now!
* +It is not adviced to disable colors if checkboxes produce the same result. (Disabled by checkbox performs better than by color.)
-------------------------------------------------------------------
* If the 'Movable Bar' Button is double clicked the movable bar duration will be pushed over 15 seconds. After that it may be increased up to 2 minutes until all bars will be cleared with the next click.
* +RightClick on the 'Movable Bar' Button to clear the unlocked bars instantly!

* Added Priest Debuff "Mind Control" (Mob Out)

* Improved: CastBar Buttons are now generated dynamically if you raise their number. (NECB does not use fixed memory for 20 bar frames anymore if you need less.)
* Fixed that disabled spells were not loaded on log in! Database name corrected (for 6.0.0+). (But you have to disable all spells again.)
* Fixed a bug that prevented cooldowns from beeing stored into the temporary database if a hostile Mob/NPC was targetted.
* Fixed a problem with the mouse input option if checked while unlocked bars were visible.
* Fixed PvP Bar spam for casting mobs with the same name. (I protected Boss Cooldowns from beeing overwritten by same named casts a bit too much.)
* Fixed: For customized spells you have to use the 'custom_localization.lua' in the specific module folder now!
* Corrected german spelling error at "Vampiric Touch" (missing 'h' in german). (Thanks to Lila)


19.12.06 '''Natur EnemyCastBar 6.2.1''' | Localizations: Taiwan, England/US, France, Germany.
* Fixed a problem with the normal Stun Diminishing Return bar not showing at all.
* Fixed Class specific Diminishing Return bars not updating on target changed if Cooldowns in PvP have been disabled.
* Outsource some more code into the modules.


17.12.06 '''Natur EnemyCastBar 6.2.0''' | Localizations: Taiwan, England/US, France, Germany.
Hint: PvE cooldowns triggered by same named boss casts were broken with previous versions and are FIXED NOW!
* NECB now supports some instant casts ("Player xy casts spell.") for PvP. Introduced the new flag "icasted=true" for PvP.
* +Added Mages "Summon Water Elemental" and "Cold Snap" Cooldowns/Durations
* +Added Druids "Force of Nature" Cooldown/Duration
* +Added Hunters "Readiness" Cooldown
* +Added Shamans "Fire Elemental Totem" Cooldown/Duration and added the icasted flag to all other Totems in database.
* +Added Rogues "Preparation" Cooldown
* +Added Paladins "Holy Shock" Cooldown
-------------------------------------------------------------------
* Added Warlocks "Fel Domination" Cooldown and updated "Amplify Curse"
* Added Druids/Shamans "Nature's Swiftness" Cooldown
* Added Warriors "Rampage" Buff
* Added Mages "Presence of Mind" and "Combustion" Cooldowns
* Added Paladins "Divine Favor" Cooldown and "Holy Shield" Buff
* Added Priests "Lightwell" Cooldown and Cast
* Added Shamans "Ancestral Healing" (Proc)Buff
* Added Paladins "Righteous Defense" to Debuffs
-------------------------------------------------------------------
* Improved Minimap Button: Better Movement and Information
* +Just RightClick and drag moves the button now. It will stay into correct position at MiniMap on different resolutions and if you swap into windowed mode.
* +The Button ToolTip now displays information about which Modules have been loaded into memory this session.
* +The Button ToolTip now displays information about increased combatlog ranges.
-------------------------------------------------------------------
* The engage detection now makes use of the new "UNIT_TARGET" event and does not poll your targets/focus' target every 0.5 secs (for 10 secs) anymore. (Only active if PvE module loaded!)
* + a) No more exceptions for C'Thun needed (hopefully)! b) The event is registered for a maximum of 10 seconds after you entered combat. While this time ONCE your 'elite' target/focus targets someone, a name check will be done and the event will be deregistered for optimum performance.
-------------------------------------------------------------------
* Fixed PvE Spells/Cooldowns not showing correctly anymore! This was caused by the new 'unknown spell' detection system. (Thanks to Blackout05 and Aegir_Mannoroth)
* +Added some common logics to the PvE spell trigger/update system in combination with updating durations done by the PvP system if the boss is focused/targetted. I guess this will show the best results now.
-------------------------------------------------------------------
* Added Event(s) "CHAT_MSG_BATTLEGROUND(_LEADER)" to detect NECB's custom timers in BattleGround channel
* Removed messages for Debuffs, PvP and Options modules loaded.
* Improved the algorithm for stacking buffs (e.g. 'Livebloom') in PvP section.
* Fixed inter-NECB-communication for battleground names of players from other realms. (Realmname was part of the name.)
* Fixed a bug in inter-NECB-communication for guild version requests if grouped.
* Fixed an error message at the engage of the three bugs in AQ40 caused by the new color sorting routine and a missing color flag in PvE database. (Thanks to Jim-Bim!)
* Fixed an error message with "/necb gcinfo" if your maximum addon memory is not more than twice your script memory. (Thanks to Jim-Bim!)


12.12.06 '''Natur EnemyCastBar 6.1.1''' | Localizations: Taiwan, England/US, France, Germany.
* Added Warlock's 'Unstable Affliction' (thanks to neilus) and 'Shadowfury' to PvP and Debuffs module, and 'Summon Felguard' to PvP module.
* Fixed an error message if spell cast events are processed right after the spell seems to have stopped ("CEnemyCastBar.lua:338: attempt to perform arithmetic on local 'UCI:startTime'(a nil value)"). (Thanks to Traver and Gagorian for report.)


10.12.06 '''Natur EnemyCastBar 6.1.0''' | Localizations: Taiwan, England/US, France, Germany.
Attention: This version includes some serious changes in event registering and splitting NECB into modules. Please check if all is functional like in 6.0.0 ;-)
* PvE/Raid Boss Casts/Cooldowns are a load on demand Addon now (Idea from 'dotted') -> saves memory and slightly increases processing speed!
* + Even if you have PvE/Raid spells enabled it will only be loaded the first time you enter an instance!
* + 'Yell, Emote and EnterCombat' Events will be unregistered if you leave an instance
* + This has no effect on RaidBosses Debuffs! These are handled separately.
-------------------------------------------------------------------
* PvP Casts and Buffs are a load on demand addon now! All spells and special code parts have been separated.
* + Events will be unregistered if "Gains" + "PvE" are disabled
-------------------------------------------------------------------
* DeBuffs/Afflictions are a load on demand addon now! All spells and special code parts have been separated.
* + Events will be unregistered if "Debuffs" + "PvE" are disabled
-------------------------------------------------------------------
* Debuff option "Only show BossDebuffs" has been replaced by an option to simply enable/disable Debuffs from Raidbosses
* + This allows you to prevent boss spells completely if other BossMods are used. (Thanks to ratkid132)
-------------------------------------------------------------------
* Spell Cast Interruptions have been improved
* All the new (WoW2.0) spells now have got their proper Icon and are enabled!
* Taiwanese Options and many spells translated (Thanks to _NiGHTs_C)
* Corrected one spell name for 'frFR' (Thanks to yom666)
-------------------------------------------------------------------
* Fixed a sorting problem caused by the "BC" in the version number of NECB BC5.6.0
* Fixed a dirty NIL error introduced with 6.0.0 (bad argument #2 to 'match') if someone broadcasted a 'Polymorph', 'Banish' etc. to you. SORRY!


04.12.06 '''Natur EnemyCastBar 6.0.0''' | Localizations: Taiwan, England/US, France, Germany.
Hint: This is a damn big improvement over previous versions. READ this Changelog CAREFULLY! Use the 'Defaults' Button for optimum settings *gg*.
* NECB now also detects and displays unkown spell CASTS (that are not in NECB's spell database!)
* + Those spells will have their text slightly green colored. Please tell me all unknown spell casts so I am able to add them (spells with a casttime (+cooldown/iconname) ONLY pls).
-------------------------------------------------------------------
* NECB supports the new Unit "focus"! Spell Casts, Stops, Delays (and Gains, Debuffs) of 'focus' will be shown now, too! Cooldowns and DiminishingReturns are still only displayed for you target.
* + A red "(F)" beneath the Bar indicates on the fly that the CastBar was triggered by a focused Unit (or a Unit with the same name!).
* + e.g. Focus a Boss and you will always see the exact CastTime even for unknown spells! Or focus a player and track the correct number of applied HoTs (if in range)!
* + Focused RaidBosses will be detected by NECB's engage system now. 'Focus' is checked over 'Target' while only elite mobs count.
-------------------------------------------------------------------
* Class specified Spells that have diminishing returns now use a database with 15 slots (similar to Cooldowns) (caused me headaches to code this :O).
* + DRs for almost every crowd control spell will be stored and considered, EVEN if it is not your current target! Only the affliction has to be displayed to keep track of DRs ,-).
* + Even DRs for spells you can't cast will be considered now, although the DR Bars won't be shown for your class.
-------------------------------------------------------------------
* "Renew", "Rejuvenation" and "Regrowth" Bars will now display a counter and try to reflect the current number of HoTs on the target (new 'HoT=true' flag!).
* + This will show wrong results if you miss some gains/fades from the Unit since in the combat log there is not posted any number of stacks!
* + The number will be underestimated by NECB because fades are detected wihtout a target, but gains (normally) not.
-------------------------------------------------------------------
* NECB sorts the CastBars by color now! Right, a new Bar will always be placed on top of same colored CastBars by pushing up other ones.
* + Changed the amount of time left when CastBars will fall down from 5 to 1 Second(s) to prevent a 'climb up' of one color.
* + I hope you enjoy it because coding this was some sort of brainsucker. Although the CastBars seem to be a bit more busy now, I like it more than the old mess.
-------------------------------------------------------------------
* NECB now supports the new WoW 2.0 crowd control duration for PvP (capped at 12 seconds!).
* + To allow a proper function of the above, broadcasting of crowd control afflictions in PvP situations has been disabled! (Increase your combatlog range instead: "/necb setrange allmax").
-------------------------------------------------------------------
* No (gfx) bug, but a feature: A little red transparent line will be placed at the top (or bottom) of the CastBars for at least 5 seconds if any CastBars were not able to be displayed because the maximum has been reached.
-------------------------------------------------------------------
* Added an sub-option to only show HOSTILE casts and gains if the 'Show CastBars even w/o Target' feature is enabled. (Thanks to tekstitys for making me think about it.)
-------------------------------------------------------------------
* Added an option to toggle mouse input! Now you may click through the CastBars to select other objects if mouse input was disabled!
* + Removed the 'Flash CastBars option' and set it to 'enabled' permanently. (You may disable it by using '/script CEnemyCastBar.bFlashit = false;' if you hate the flashes.)
-------------------------------------------------------------------
* Added an option to hide the border of all CastBars. (default: enabled)
* + NECB will change your CastBars' Space (to 15), Alpha (to 0.8) and Width (to +20) the first time you log in to adjust the 'new' style.
* + Removed the 'Use Small Text' option and set it to 'enabled' permanently. (You may disable it by using '/script CEnemyCastBar.bSmallTSize = false;' or use the 'scale' setting set a bigger text.)
-------------------------------------------------------------------
* Added a Slider to change the TEXTURE of the CastBars. You may choose out of 16 textures now! (Thanks to Ora2, SW_Stats for their files.)
-------------------------------------------------------------------
* An info message appears if you enter the game and a) increased combatlog range or b) disabled spells have been detected.
* An info message appears if the engage protection has been activated by a boss pull.
* + Remember, the engage protection prevents corrupted (broadcasted) boss timers caused by people who get out of combat and enter it again (Hunters, Rogues).
* + For bosses that trigger the protection, it should always being reset before an engage. Otherwise you won't see all boss timers...
-------------------------------------------------------------------
* "/necb help" and "/necb (g)version" now use scrolling text frames!
* + "/necb help" extended.
-------------------------------------------------------------------
* NECB will now detect all kinds of alterations for casts like "Create Healthstone" (automatically detects ..(Greater) ..(Major) etc.)
* + Same with afflictions which have suffixes in brackets (e.g. Fearie Fire (Feral), Mangle (Cat) ). Suffixes not needed in NECB's database anymore.
-------------------------------------------------------------------
* The MiniMap button may now be moved freely with ALT + RightClick. (Thanks to bsmorgan for his 'request'.)
* + The slider to move the button has been replaced by a simple checkbox to hide/show the button.
* + If you change screen resolution toggle this option to reset the button position if you can't find it anymore.
-------------------------------------------------------------------
* The free FPS-Bar can now be fixed into position (mouseinput disabled) by enabling the right checkbox in options menue.
-------------------------------------------------------------------
* Added SlashCommand "/necb wipe" which plays the BennyHill sound. Leader or promoted required!
* + I have 'stolen' this idea from CT_RA Multi, because my raid does not use it anymore but likes the typical 'wipe sound'.
-------------------------------------------------------------------
* Unknown Icontextures now become a questionmark-icon instead of not beeing displayed in case the option to show icons is enabled.
* Added 'Fearie Fire' (Thanks to shaten), 'Lightning Breath', 'Lightning Cloud' and 'Diseased Slime' to Mob spell casts.
* Added "Cold Blood" (Rogue talent) CoolDown.
* + "Cold Blood", "Elemental Mastery" and "Inner Focus" will update their CoolDown CastBar on fade (to be very exact). (New PvP flag 'onfade=true' added!).
* "Last Stand" (Warrior) Cooldown reduced to 8 minutes.
-------------------------------------------------------------------
* Show/Hide Icon setting will now be applied (instantly) to existing bars, too.
* FPS Bar Range has been changed to 1-60 FPS (from 1-100 FPS).

* Fixed two bugs in the "/necb (g)version" feature.
* + One was caused by LUA5.1 that does not allow to modify the counter of running 'for-loops' anymore. The other bug was a color error in rare cases.
* Casting Events are now properly unregistered while changing zones.
* Added Naxxramas Zoneflag to Gluth's fear to prevent faulty triggers in UBRS.
* Added another check to the parsing function to prevent a possible error caused by unsuspected calls (Reported by Motion11).
* Fixed: Cooldowns will only be displayed for your current target even if you enabled 'Show CastBars w/o Target'.
* Fixed an error message that occurs if a character enters the game world with NECB for the very first time.
* Minor code improvements that speed up things.

* zhTW and frFR translation for the options localization requested! Mail your textfiles(!) to 'Naturfreund@digital-joker.de'


17.11.06 '''Natur EnemyCastBar BC5.6.0''' | Localizations: Taiwan, England/US, France, Germany.
Tip: Use "/necb setrange allmax" to increase your combat-log range dramatically! ("/necb setrange" sets it back to defaults.)
-------------------------------------------------------------------
* FULL Burning Crusade and Patch 2.x compatibility (and some neat improvements).
-------------------------------------------------------------------
* Spell Delays, Stops and true CastTimes are detected now!
* + NECB uses a powerful mixture of combatlog and new UnitCasting Information.
* + No more CastBarSpam if other mobs with the same name Cast anything or if players cast/stop/cast/stop..! Keep in mind all this only works if you have a Target.
-------------------------------------------------------------------
* NECB will now distinguish between friend or hostile even if the caster has not been targetted! (For enabled "CastBar w/o target" option.)
-------------------------------------------------------------------
* People who used "/necb cast SpellName" now have to use two additional lines for their macros:
/script NECBCustomCasted = true;
/cast SpellName
/necb cast SpellName
By using the above lines it still works like before!
-------------------------------------------------------------------
* "/necb gcinfo" now takes advantages out of the new LUA 5.1 GarbageCollecting System.
* + Garbage will be collected instantly if you call NECB's info window by using the above command.
* + Garbage may now be collected by user input (new button). This might be useful before important fights when you don't want to be stressed by any slow downs caused by a Collection Cycle ;-)
-------------------------------------------------------------------
* Cooldown Options revised: There is only one option left and reset button added to clear the Database.
-------------------------------------------------------------------
* Option for spell interruptions changed: Now it only can be switched on/off completely.
* + Minor performance improvement.
-------------------------------------------------------------------
* Default Settings changed.
* Feature to target Units by LeftClicking the CastBars has been removed (prohibited by WoW API now).


16.11.06 Natur EnemyCastBar 5.4.8 | Localizations: Taiwan, England/US, France, Germany
* Added Respawn Timer for Naxxramas "Necro Stalker" (30 min) (frFR and zhTW translations missing)
* Added Hunter Afflictions "Counterattack" (DeBuff-Section) and "Scorpid Sting" (DeBuff-Section but visible for Hunters only) (Thanks to perunaion)
* Reduced the CastTimes of "Ghost Wolf", "Wrath" and "Starfire" as if they had full talent points invested
* Cooldowns from targetted NPCs won't be stored to the temporary Database anymore. If the NPC is targetted afterwards the Cooldown will be removed instantly.
* Hint: You don't need to enable stuns to detect all spell-interruptions. Removed a wrong description from the 5.3.8 changelog. (Thanks to nezhar)


13.11.06 Natur EnemyCastBar 5.4.6 | Localizations: Taiwan, England/US, France, Germany
-------------------------------------------------------------------
* New SlashCommand: "/necb setrange allmax/cmax/blank" sets the Range of the CombatLog to have a much larger radius of spell detection!
 + 'allmax' will increase the Range of ALL combatlog messages (Most usefull for a broadcasting MainTank!)
 + 'cmax' will only increase the Range of Creature messages by factor 5 (set to max.)!
 + Just "/necb setrange" will set all CombatLogRanges back to defaults
+ Once you entered the new command the values will be written into your Config.wtf permanently (notice: other Addons might override them!)
+ Increasing the combatlog range might result in a significant higher CPU consumption of ALL Addons that parse the combatlog, because of more detected messages!
-------------------------------------------------------------------
* Added Mob Spell "Lizard Bolt" and "Plague Mind" (zhTW translation missing)
* Changed some code that initializes the AddOn when the player enters the game world. That should prevent a possible error message.
* Fixed a Bug that displayed Debuff-Bars for your own Charakter. As intended that only works for Boss Debuffs from now on.
* Reordered "/necb help" a little


10.11.06 Natur EnemyCastBar 5.4.4 | Localizations: Taiwan, England/US, France, Germany
* Added new slash command "/necb cooldowns" - Displays all detected Cooldowns currently in Database.

* Added Enraged Timer and "Life Drain" Cooldown for Sapphiron (Naxxramas) (frFR translation missing)
* Added "Detonate Mana" for Kel'Thuzad (Naxxramas), Raid-Affliction
* Added Molten Core Shazzrah "Gate of Shazzrah" (Teleport) Cooldown; keep in mind Shazzrah won't teleport exactly after 45 secs - there is a random delay (Thanks to BBR)
* Added MobSpell "Flamespit" (Fireroc/Tanaris) (zhTW translation missing)
* Added Druid Talent "Nature's Grasp" and "Bestial Wrath"
* Druid Afflictions changed: "Bash" duration now scales with player level; "Feral Charge - Effect" renamed into "Feral Charge" and stun-flag removed

* Fixed wrong Enraged Timings for Patchwerk (Naxxramas) with zhTW clients.
* Added Mage 'Pet' Spell "Waterbolt" and Druid Affliction "Maim" and "Mangle" for Burning Crusade
* Added new flag "cpclass" to Afflictions section. This one indicates if the combopoint sensitive spell is either used by Rogues or by Druids.

* Thanks to BabbleLib2.2 for some translations


01.11.06 Natur EnemyCastBar 5.3.9 | Localizations: Taiwan, England/US, France, Germany
* Added Event "CHAT_MSG_SPELL_AURA_GONE_PARTY" to detect fading buffs/debuff of your party members
* Reduced "Chain Lightning" and "Lightning Bolt" by 1 second. (Thanks to ciferfromger)
* Translated almost every FRENCH Boss Spell (Thanks to BigWigs Addon)


21.10.06 Natur EnemyCastBar 5.3.8 | Localizations: Taiwan, England/US, France, Germany
* The options window now displays the number of recognized and stored Cooldowns if the internal Database is enabled: (n/50)
 + The number will only be updated if you change your target or if a new CD is detected/stored.
* If a spell-interruption is detected the appropriate cooldown will be deleted from the database and cleared from the screen.
* Fixed a bug that triggered Cooldowns if people were afflicted by a spell that has a cooldown parameter.

* Added Cooldown for Priest Talent "Inner Focus" and Shaman talent "Elemental Mastery". The duration is just a rough guess for these spells!

* Prepared NECB for the following new Burning Crusade spells/talents:
 + Druid: Cyclone, Lifebloom - Mage: Invisibility, Ice Lance, Slow - Hunter: The Beast Within - Paladin: Avenging Wrath, Divine Illumination, Avenger's Shild - Priest: Mass Dispel, Binding Heal, Pain Suppression - Warlock: Seed of Corruption, Ritual of Souls, Incinerate - Warrior: Victory Rush, Spell Reflection - Shaman: Shamanistic Rage - Rogue: Adrenaline Rush, Cloak of Shadows

* Added taiwanese translation of the new Cooldown feature and of Gothik's Events
* Added mcheck to Chromaggus "Incinerate" to prevent Bars triggered by new BC Mage Spell (just a preparation)
* Renamed german Warlock spell "Schreckgeheul" into correct "Schreckensgeheul"


17.10.06 Natur EnemyCastBar 5.3.5 | Localizations: Taiwan, England/US, France, Germany
-------------------------------------------------------------------
* Added new Feature: Cooldowns of all players in combatlog-range will now be stored into an internal Database if enabled. Up to 50 active CDs will be remembered!
 + CD Bars will be displayed instantly if you select a target and a spell with a CD was detected before
 + If you change targets the CDs of your old target will be removed automatically (but they will still be remembered and displayed again if you switch back ;-) )
 + CDs of Spells with a CastTime will have their CastTime added to the CD-Time and NECB won't check if this spell has been interrupted for peformance reasons!
 + You may clear the database via "/script NECB_CD_DB = { };" or just disable and enable the feature to clear it.
  + No, this will not be added for Gains/ Afflictions because then a very big database will be needed and you will notice an extreme slowdown...
  + You have to ENABLE this feature. It is disabled by default.
  + Thank EvilGenius007 for this feature request :D
-------------------------------------------------------------------
* Gothik (Naxxramas) Waves deleted and First Income and repeater for Deathknights, Riders and Trainees added (Thanks to funkydude)

* Removed Debug output introduced with NECB 5.2.5 "/necb remove" number only support :/
* Removed an unnecessary CD Bar check if casts were interrupted. (I guess it is unnecessary since NECB 5.2.5 ;-) )


05.10.06 Natur EnemyCastBar 5.3.0c | Localizations: Taiwan, England/US, France, Germany
* TAIWANESE version only: a) Spell interruptions are detected now, b) C'Thun eye timers translated (and some code cleared) (Big thanks to CuteMiyu!!!)
* I still need many translations for french version: open localization.fr.lua, search for "--!" and translate those spells pls ;-)


03.10.06 Natur EnemyCastBar 5.3.0b | Localizations: Taiwan, England/US, France, Germany
* Fixed not broadcasting clients because of a wrong presumption of the "GetNumBattlefieldStats()" values. (Thanks to Jenay!)
 + I thought outside a battle field it will always return a "0", but it also returns a "1". Tell me more if you know exactly why this is the case...


02.10.06 Natur EnemyCastBar 5.3.0a
* Fixed error messages if a not supported client language is beeing used (e.g. 'GFind' error). Displays a warning in this case.
* Fixed a minor error in XML (s. FrameXML.log). (Thanks to funkydude)


29.09.06 Natur EnemyCastBar 5.3.0 | English/US, German, French and > Taiwanese < clients supported now!
OK, to make it short: I dramatically reduced the time I invest into this AddOn, but that does not mean I don't love my 'baby' anymore ;P
I will try to maintain and administrate this project as long as possible. Feels good atm. Don't expect new features coded by me ;-)
* Added Taiwanese support! Nearly all done by CuteMiyu! Hope CuteMiyu will keep up his great work ;-)
 + I used a very dirty but easy way to support asian languages. Just two new files (ASIAN and USEU) with outsources code were built up.
 + If anyone does not like it this way: It was the fastest working way for me to merge them ;P

* Fixed a stupid bug in the "SpellBreak" Options (Thanks to Adron1111)

* Added AQ40 Eye Timer for C'Thun (Thanks to funkydude again and again!)
 + Taiwanese version not translated for this one, yet. (Wink to CuteMiyu ;-))


24.09.06 Natur EnemyCastBar 5.2.7
* Fixed missing "whisper button" for "/necb (g)versions" (line 1346) (broken with 5.2.6)
 + "whisper button" now only is displayed if different versions are detected
* The countdown at the right of any CastBar now only displays tenths of a second if less than 10 seconds are left.


21.09.06 Natur EnemyCastBar 5.2.6
* Added "/necb gversions" to check versions of your online guildmembers.
* Fixed a bug with the new/changed EngageDetection not working at all. (Defined locally although it was needed outside the if-clause :/ )


20.09.06 Natur EnemyCastBar 5.2.5a
My last version of NECB, feel free to release your own versions. I am quitting to play WoW seriously.
* Bugfix for line 2713 error


18.09.06 Natur EnemyCastBar 5.2.5
Some bosses require to have them targetted to trigger PvE CastBars (or to unlock other castbars) on engage!
(BWL: Firemaw, Ebonroc, Flamegor; AQ40: Three Bugs, Ouro, Huhuran, Twins, C'Thun; Naxxramas: Gluth, Maexxna, Loatheb)
-------------------------------------------------------------------
* Added new slash command "/necb chat yourtext"
 + 'Yourtext' will be send to other users who use NECB. You are able to chat with other NECB users in your group exclusively now! (Thanks to funkydude for this idea.)
 + In Raids the author will be displayed in class colors ;-)
-------------------------------------------------------------------
* New Feature/Option: PvP CastingBars will disappear if the cast is interrupted by a skill! (Thanks to Lazarus for idea/code parts, Namatsar for translation)
 + Remember that this function will be 'screwed' (like many others) if there are multiple mobs with the same name
 + Currently there is an option to disable the feature if in a RaidGroup. If for any reason you want to disable this feature completely type in "/script CEnemyCastBar.bDisableInterrupt = true;". To enable it again type in "... = nil;" instead of "... = true;"
-------------------------------------------------------------------
* Added another protection for all character classes to prevent wrongly assumed Boss engages (although the 'Bloodrage' problem only affected Warriors) (Thanks to funky for idea/telling me again^^)
 + It is adviced to have between 4-6 people to broadcast NECB events. Broadcasters should target the Bosses before they engage them...
 + After you entered combat the new check is redone once every 0.5 secs over the next 10 seconds (and stops if your target is in an active combat or has a target).
 + C'Thun is not protected. You will always trigger a bar if you enter combat after you targetted C'Thun.
-------------------------------------------------------------------
* Cooldowns for spells with a casttime will now be triggered AFTER the spell has been executed. (So interrupted spells won't trigger a CD.)
* Cooldowns for PvP Spells will only be displayed if your current target is a PlayerCharacter or if you have enabled "Show CastBars even w/o Target".
-------------------------------------------------------------------
* "/necb remove spell or number" now will also accept the spell number instead of the spell name to make removals more easy.
 + "/necb disabled" will print the spell number right after the spell name
-------------------------------------------------------------------

* Added german translation of "Inevitable Doom" (Naxx, Loatheb) (Thanks to 'BigWigs')
* Added french translation of Heigan's engage Yells (Thanks to 'CT Bossmods multi')
* Added Onyxia's Deep Breath cast duration (Thanks to funkydude)
* Added AQ40 Ouro Submerge Events (Thanks to funkydude!)
* Fixed AQ20 Ossirian "Nature Weakness" (Thanks to funkydude)
* Naxxramas "Locust Swarm" (Anub) will have its cooldown bar deleted if this spell is detected. (Thanks to funkydude)
 + Added new RaidSpell flag 'delBar="SpellName"' for that purpose
* Naxxramas "Summon Spore" and "Remove Curse on Loatheb" added for Loatheb (french translation missing) (Thanks to funkydude)
* Naxxramas 'Waves', 'Deathknight' and 'Rider Incomming' added for Gothik (Thanks to funkydude!)
* "Conflagration" will only be triggered in "Blackwing Lair" now. (Thanks to funkydude)
* Fixed Naxxramas Noth disappering "Blink" caused by a fading "Blink" right after he ported (Thanks to funkydude for the report)

* Changed the FrameStrata of the CastBars from "High" to "Medium". (Now the CastBars are behind your Bags.) (Thanks to Manigra)
* Fixed missing icon for "Ice Barrier" (german clients) and deleted a doubled line in localization.lua's (Thanks to CuteMiyu)
* Added "Armor of Faith" (Priest T3 gain/proc) to PvP Section (Thanks to funkydude)
* Some changes how the name of the three bugs (AQ40) is beeing detected.
* Changed the way MobNames are bound to CastBars (internal code adaption)
* Moved more on demand code from the Main Addon into the Options Addon!


31.08.06 Natur EnemyCastBar 5.1.7
* Added Naxxramas "Power Surge" for Thaddius encounter (fr missing) and added estimated Enrage timer for phase 2!
* Added Naxxramas translation of "Polarity Shift" (Thaddius) for german clients (fr still missing)
* Added Naxxramas translation of "Necrotic Poison" (Maexxna) for french clients (german one is only a guess :/)
 + Thanks to the BigWigs and Bossmods Multi team for some translations!
* Changed the engage yell for Sartura (AQ40) for de + en (fr still uses the old one) to achieve an accurate timing. (Thx to funky for pointing out this issue)

* Added "Demoralizing Roar" and "Faerie Fire (Feral)" to Debuffs. Only Druids are able to see them. "Faerie Fire (Feral)" is only visible if you have the talent!
* Added "Crystal Gaze" to MobSpells (PvP section)

* Added new slash command "/necb combatlog". If enabled NECB will write the parser messages to the combatlog, too.

* Fixed some spells which inherit a "-" because Blizzard has changed their names for german clients.
* Changed: The 'tchange' RaidSpell flag (used for the Enrage timer of Thaddius) will now automatically enable the EngageProtection to reset changed durations for the next try.
* Changed the text when someone whispered old versions of NECB to update into "NECB: 'Player' notified some users!" (Some people were confused by the old message text.)
* Changed the max. latency from 500 to 750ms for broadcasts


28.08.06 Natur EnemyCastBar 5.1.5
* Fixed an error with "/necb stopbc, forcebc" if the on demand options addon was not loaded before. (Thanks to funkydude for this hint!)
* Fixed not showing the Color Frame. (Thanks to rennik846)
* Fixed (Un)Registering Events some time after the AddOn has been loaded. (This is a very old issue, finally found and reported by funkydude!)
 + Now NECB really catches no combat events any longer if disabled! It uses nearly NO CPU power then :D

* Removed the "Only show gains" checkbox/feature out of the "CastBar w/o Target" section into the "Show 'gains' section".
 + Check your settings, because the same variable has been used!
 + This is more user friendly and logical I think. (Thanks to funkydude for this request)

* Added "Wither Touch", "Fevered Fatigue", "Encasing Webs" to Mob (PvP section) spells.

* Translated "AddOn Updates per Second:" and its tooltip into french. (Thanks to namatsar)
* Every CastBar created by the menue has an icon now (if icon feature enabled).
* Disabled myAddOns Options for NECB


26.08.06 Natur EnemyCastBar 5.1.0
Attention: Also copy "CECB_Options" (loaded on demand) into your ..\Interface\AddOns folder! Otherwise you aren't able to use the menue anymore ;-)
+ You have to reposition your CastBars because the Options have been outsourced into a separate AddOn folder!
-------------------------------------------------------------------
* Increased performance of NECB by only updating any CastBar 20, 10, 7 and 5 times per second instead of doing it at maximum fps! (Thanks to Tain for this suggestion!)
 + This will improve performance for people who play with more than 20, 10, 7 or 5 fps depending on the setting you choose.
 + New slider added to adjust this setting :D
 + Default is 20 fps. Before 5.1.0 it was updated with maximum fps!
-------------------------------------------------------------------
* The Options Frame is now loaded on demand by moving it to a separate 'CECB_Options' AddOn! (Thanks to Tain for this idea!)
 + This will save about 100kb of AddOn Memory until you open the options menue.
-------------------------------------------------------------------

* Added "Faerie Fire" to Druid afflictions, only displayed for Druids. (Requested by ainu)
* Added "Demoralizing Shout" and "Thunder Clap" to Warrior afflictions, only displayed for Warriors.
 + Yeah, finally we reached the ultimate CastBar madness! Mission accomplished ;-)
* Changed "Rupture" (Rogue, DoTs) to patch 1.12 values. (Thanks to Merimal)

* The setting of the FPS Bar will now be remembered. So you don't need to enter the menue after you have relogged.
* Fixed a bug with "/necb versions" overwriting the blue names of broadcasters after an update of the window.
* Fixed a problem with apostrophes for german clients if spells are stacking
* Stacking BossDebuffs will now be broadcasted
* Enhanced the feedback of the 'whisper users to update their NECB' feature.
* Disabled messages if the ChannelParser is opened/closed.
* Now detects an "enGB" client and uses the same database as "enUS" (Thanks to Walrock)
* Other minor changes.


22.08.06 Natur EnemyCastBar 5.0.0 | Advise: Since the communication system has been changed with patch 1.12 ALL users should update their version to this one!
Tipp: You are always on the safe side if you have targetted the Boss when you engage/enter combat (and want to see an initial CastBar) ;-)
-------------------------------------------------------------------
* NECB uses the new command 'SendAddonMessage(prefix, text, "PARTY"|"RAID"|"GUILD")'
 + No CTRA Broadcast needed anymore, the clients will communicate instantly through the new AddOn Channel!
 + Version checks will be possible anytime now (not only after CTRA Broadcasts anymore) and versions will always be regathered on demand!
 + And the best: Spell Sync and Version checks are possible in party and battleground groups, too! (Not only in RaidGroups anymore!)
-------------------------------------------------------------------
* New Feature: The CastBar's width may now be modified! (Thanks to Tamelon for this idea.)
-------------------------------------------------------------------
* New SlashCommand: "/necb showbar spellname" - Shows a CastBar without waiting for any combatlog message! (Ideal for DoTs, HoTs!)
 + Great for spells that trigger a proc that has not the same name as the spell, which won't work with "/necb cast Spell". (E.g. "Frostbolt" -> "Winter's Chill"...)
 + Will only trigger a Bar if you have selected a target! Friendly targets only allow friendly spells (HoTs...); Hostile targets only allow hostile spells (damage, DoTs...)
-------------------------------------------------------------------
* New Feature: "/necb versions" now also has a button to whisper all users with old versions of NECB to update!
 + Users who enabled the broadcasting feature will now be displayed in blue color.
-------------------------------------------------------------------
* New Feature: "Only show 'gains' w/o Target" will only display 'gain' CastBars for Units you don't target. (Thanks to isokarhu for this idea)
-------------------------------------------------------------------
* New Feature: Put your custom spells/'events' into "custom_localization.lua" and you won't need to redo your changes once a new version is released :D (Thanks to Mriswith2k for this idea)
 + Some examples added to the custom database (e.g. demo shout). You may uncomment them to achieve support.
-------------------------------------------------------------------
* New Feature: The Menue now will inform the user about the status of the EngageProtection(TM *just kiddin'*). A reset button was also added ;-)
 + The EngageProtection was introduced (some versions ago) to prevent CastBars triggered accidently if hunters feign death or rogues vanish and enter combat again (while targeting the boss)
-------------------------------------------------------------------
* New Feature: Now there is an option to play a Sound whenever a Raid CastBar begins to flash. (Thanks to Irion for this idea!)
-------------------------------------------------------------------
* New Feature: Slashcommand "/necb forcebc raidmember" will force your raidmember to broadcast CastBars by enabling his/her settings: Debuffs, PvE, Global MobOuts, Channelparsing, Broadcasting!
 + Slashcommand "/necb stopbc raidmember" will stop broadcasts of your raidmember by disabling his/her settings: Broadcasting!
 + You may just use "/necb forcebc" or "/necb stopbc" if you have targetted the specified raidmember ;-)
 + You need to be leader or promoted to use these commands!
-------------------------------------------------------------------

* Boss Afflictions/Debuffs against Players will now have a blue shadowed Text! (Your name will still be red shadowed ;-) )

* Reactivated AQ40 "Weakened!" and "Dark Glare" CastBar for C'Thun(fish)
 + "Dark Glare" might be inaccurate after some time! (Tell me your experience pls, but stick to rules below.)
 + The one who engages C'Thun and 'enters combat' should be a broadcaster for this event! Otherwise use '/script CEnemyCastBar_Control("C'Thun", "First Dark Glare", "engage");' as soon as your group engages him!

* Added Naxxramas Patchwerk 'Enrage Timer' (Thanks to funkydude)
* Added Naxxramas Gluth "Terrifying Roar", "Decimate" and "Mortal Wound". "Mortal Wound" will work for Kurinaxx and Frankriss, too. (Many thanks to funkydude)
 + Target Gluth if you engage or the "Decimate" Event won't be registered by your client ;-)
* Added Naxxramas Razuvious "Disrupting Shout" (Thanks again to funkydude)
 + You should have a broadcaster who transmits the 25 sec cooldown by beeing in combatlog range of Razuvious to keep the EngageProtection enabled. Otherwise the timer might get screwed by later yells!
* Added Naxxramas Anub'Rekhan first "Locust Swarm" if the yell is detected and added a more detailed sequence. (Thanks to funkydude)
* Added Naxxramas Maexxna "Web Spray", "Web Wrap" (Boss Affliction) and "Necrotic Poison" (Boss Affliction/ de, fr missing!) (Thanks again to funkydude *g*)
* Added Naxxramas Faerlina "Enrage" and "Widow's Embrace" (Thanks to funkydude)
* Added Naxxramas Grobbulus "Mutating Injection" (fr missing!)
* Added Naxxramas Thaddius "Polarity Shift" (de, fr missing!)
* Added Naxxramas Loatheb "Inevitable Doom" (de, fr missing!). First Doom (120 sec), 30 sec and 15 sec Doom CD supported! Also added 300 sec timer until 15 sec Doom CoolDown madness.
* Added Naxxramas Gothik "Comes Down" (fr engage 'yell' missing!)
* Added Naxxramas Heigan "Teleport CD", "On Platform" (fr 'yells' missing!)  (Thanks to funkydude, the official NECB Naxxramas Boss checka!)

* Added AQ40 "Summon Ouro Mounds", "Summon Ouro Scarabs", "Sand Blast", "Sweep" for Ouro (Thanks to funkydude, great explanation!)
* Added AQ40 Twins first(!) "Twin Teleport" Cooldown
* Added AQ20 "Paralyze" for Ayamiss the Hunter
* Added AQ20 "Fire/Nature/Frost/Arcane/Shadow..Weakness" for Ossirian
* Added Zul'Gurub "Enraged mode" for Hakkar (Thanks to Nirek)

* Added "Curse of Blood", "Plague Cloud", "Dark Sludge", "Wandering Plague" (Mob Spell) to PvP Spells (Thanks to Anolin)
* Added "Curse of Exhaustion" (Warlock) to "DeBuffs"; Only visible to Warlocks are "Curse of Tongues" and "Curse of Doom" (Thanks to funkydude)
* Added "Shadowburn" (Warlock) to DoTs (handled as DoT internally) (Thanks to funkydude)
* Added "Exose Armor" (Rogue) to "DeBuffs"; Only visible to Rogues! (Thanks to Zyrxil)
* Added "Blast Wave" (Mage) to "Solo DeBuffs; StunColor" and "Flamestrike" to DoTs (Thanks to Dustine, funkydude)
* Added "Silence" (Priest) to "Solo DeBuffs" (Thanks to Gastro)
* Added "Heal" (Priest) to PvP spells
* Added "Wyvern Sting" (Hunter) to "Solo DeBuffs" (Thanks to sr1030nx)
* Added talent point check for "Shadow Word: Pain" (Priest) (Thanks to Gastro)

* Changed "Twin Teleport" from 25 to 30 secs. (Thanks to funkydude)

* Fixed "Métamorphose : cochon" and "Métamorphose : tortue" (Thanks to BiDOrD)
* Fixed Yauj's Fear Castbar displayed for Anubisaths after Twins. -> Added new 'checkengage' flag to RaidSpells as a solution to this problem.
* Fixed bar spam of "Entangling Roots" at Anubusaths after Twins. -> Added new 'blockZone' flag to Afflictions section as a solution to this problem.

* aZone="InstanceName" will also be checked for spells of the 'Afflictions' section now! (Not only for the 'Raids' section.)

* 'aBar' is a new RaidSpell flag that will trigger the defined spell instantly when the source CastBar runs out (e.g. 'Dark Glare'). (Thanks to funkydude for this idea!)
 + 'aBar' will only trigger the next CastBar if the User is in combat or is dead! So, it just runs out if the fight is over^^
 + CastBars triggered by 'aBar' won't be broadcasted to the raid. It is meant to be a completely internal system, because the initial source spell should be the only Event which has to be broadcasted.

* 'pBar' is a new RaidSpell flag similar to 'aBar' but will trigger the defined spell instantly when the source CastBar APPEARS! (e.g. 'Web Spray')
 + CastBars triggered by 'pBar' won't be broadcasted to the raid. As opposed to 'aBar' this one does not check if you are in combat or dead!

* tchange={"SpellName", duration1, duration2} is a new RaidSpell flag that will change the duration of the defined Spell when the CastBar runs out (e.g. tchange={"Inevitable Doom", 30, 15} for '15 sec Doom CD!' Bar). 
 + duration1 is applied (reset to default duration) if the EngageProtection is disabled and the player enters combat the next time. (Multiple modified durations will be remembered by NECB.)

* Some minor fixes

* Many thanks to NAMATSAR for the always fast translations of the menue into french :D
* Thanks to the BigWigs Author for some spell names and text strings

* Renamed "CT_RA_readme.txt" to "NECB_Interface_readme.txt" and changed the context to reflect the Introduction of the new patch 1.12 com-system!
* Updated TOC for Patch 1.12


19.07.06 Natur EnemyCastBar 4.7.0 | TIP: Please read the changelog carefully :D This time it has much information you must not miss (many engine improvements!)^^
-------------------------------------------------------------------
* New SlashCommand: "/necb cast spellname"! 1. Casts the spell for you and 2. Shows a CastBar without waiting for any combatlog message! (Ideal for DoTs, HoTs!)
-----------------Exclusively written for kleys *g*-----------------
+ This allows the User to use new powerful MACROs (ONLY use with DoTs, HoTs!) (e.g. "/necb cast Renew")
+ This allows you to trigger castbars even if there is NO combatlog message! To renew HoTs BEFORE they run out +++
+ NECB will check if Target is friendly for HoTs or enemy for DoTs
+ It even will prevent the CastBar from beeing updated if a spellcast error occured :D (Works for most errors but "Out of sight!")

+ BUT this will only help yourself, other users who don't receive a combatlog message won't see any CastBar action!
+ BUT NECB does not know if your spell has a CastTime! The Bar will instantly start after you pressed the button.

+ For PvP Spells (e.g. 'spellname' = 'Renew') NECB will always assume you trigger a 'Gain' (other spells seem to make no sense)
+ NECB will automatically choose from Afflictions Database (e.g.: 'spellname' = 'Hamstring').
+ NECB will automatically know it has to trigger the DoT Bar and has to increase its duration some secs (e.g.: 'spellname' = 'Shadow Word: Pain').
(The castbar appears some millisecs before the server actually notices you have casted something. The timings might differ around one second after all in total + integrated lag compensation!)
-------------------------------------------------------------------

* Changed "/necb deletedot label" to "/necb deletebar label"!!!
+ This will delete ANY bar with the partial text 'label'!
+ ONLY CastBars that match the Targets Name will be removed! (DoT CastBars for 'Snake' won't be removed if you target 'Lion')
+ In some cases this + "/script CastSpellByName("spell");" is more safe and accurate than "/necb cast spellname"
-------------------------------------------------------------------

* Added: The NECB engine is now able to recalculate Afflictions/DeBuffs which have a modified duration from INVESTED TALENT POINTS!
+ "Gouge" (Rogue), "Freezing Trap Effect" (Hunter), "Bash" and "Pounce" (Druid) use the new feature :D (For "Gouge" every talent point adds 0.5 secs to its duration)
-------------------------------------------------------------------

* Added: The NECB engine is now able to recalculate Afflictions/DeBuffs which have a modified duration from PLAYER LEVEL!
+ Only your CharacterLevel will change the duration of all CastBars that check the player level. (This will not check the used skill level, so upgrade your skills as soon as possible.)
+ "Polymorph..." (Mage), "Freezing Trap Effect" (Hunter), "Shackle Undead" (Priest), "Banish" (Warlock), "Sap" (Rogue) and "Hibernate" (Druid) use the new feature :D
-------------------------------------------------------------------

* Changed: Multiple CastBars for DoTs possible now if cast on multiple targets!
* Changed: CastBars for Gains (PvP Spells, e.g. "Renew") are updated now instead of producing multiple bars for one target.
* Changed: NECB HELP and VERSIONS now both open a shared window to display information instead of using the Chat Window!
* Changed the CastBars Texture (Thanks to Artack, SW_Stats for the texture file)
* Changed: Gains that stack (e.g. "Spellname (n)") are beeing detected by NECB now (needed for "Healing Way")!
* Changed: "Magic Reflection" (Majordomo) won't be triggered outside of MC anymore (Thanks to funkydude)

* Added Hunter Afflictions: "Concussive Shot" , "Viper Sting" (displayed for hunters only), "Scatter Shot" ('Solo DeBuffs') (Thanks to Vaun!)
* Added "Siphon Life" (Warlock) to 'Own DoTs' (Thanks to ma1f)
* Added Shaman Proc "Ancestral Fortitude" and "Healing Way" (Thanks to kleys)
+ For "Healing Way" use macro: '/necb cast Healing Way' (enter new line!) '/script CastSpellByName("Healing Wave");' to trick the missing combatlog message after three stacks!
* Added Mob Spell "Curse of the Deadwood" (Thanks to Anolin)

* Colored "/necb parser" messages: grey = automatic message; bright yellow = triggered by user input

* Removed Troll racial spell "Shadowguard" (Thanks to Jorad)

* Prepared NECB for patch 1.12 (New: SendAddonMessage(prefix, text, "PARTY"|"RAID"|"GUILD") command.)
 + This will be the end of the CTRA Dependency ;-)
 + Version checks will be possible anytime (not only after CTRA Broadcasts anymore) and versions will always be regathered on demand
 + And the best: Spell Sync and Version checks will be possible in normal groups, too! (Not only in RaidGroups anymore!)

* Added French Translation! (MANY Thanks to namatsar for this unexpected support!)
-------------------------------------------------------------------


12.07.06 Natur EnemyCastBar 4.6.0 | Tip: Use "/cecb deletedot label" macro if you renew any DoT without initial damage ;-)
* Added "/cecb deletedot label" - Stops all DoT CastBars which inherit the text 'label'. "/cecb deletedot all" deletes every DoT CastBar!
 + Create a macro ("/m") that resets the DoT CastBars and then casts your DoT spell to have accurate CastBars if you renew your DoTs before they run out :D
 + Macro example:
 /necb deletedot Pain
  (Enter new line! Keep in mind that 'label' is case sensitive! So "pain" won't work!)
 /script CastSpellByName("Shadow Word: Pain");

* Added new slash command "/necb add xyx". This allows to disable a single spell by entering its spell name (xyz) (s. /necb help)

* The two spell flags checkevent="eventname1 - eventname2.." and aZone="MapZone" were moved to the beginning of the PvE section. If defined and not true the PvE section will be canceled and PvP, DeBuff will be parsed!
 + This allows the same spell in PvE, PvP and DeBuff section simultaniously if one of the flags "checkevent", "aZone" or "mcheck" is used correctly.
 + This fixes a problem with the spell "Fear" which is used in any of these sections ;-)

* "Fear" (Warlock) time corrected, now displays a shared DR Timer with "Seduction" (Thanks to d00m2k for his hint and to Shredmasta for testing this with me.)

* Fixed duration of "Erneuerung" (german client)! (I forgot to change it back from 150 to 15 secs after a debug session :/ ) (Thanks to Enlighted for his hint.)
* Fixed: PvP Spells casted by you will never trigger a CastBar. (Normally there does not appear a combatlog message, but I added a protection to be on the safe side.)
* Fixed: RaidSpells which check the eventname will now trigger a castbar for the receiver when broadcasted (Thanks to Mysthe to let me think about this topic *g*)
 + Attention: Hakkars blood siphon used another trigger event with version 4.1.0 (and older) so bear in mind:
 + There should be no broadcaster with these old versions in your raid, otherwise those old, broken timers will be broadcasted to everyone!
 + Hakkar's blood siphon now only triggers a castbar if the "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" (mob gains) event is fired (remember what I said about old version broadcasts before ;-) )

* Added 'myAddOns' Help


05.07.06 Natur EnemyCastBar 4.5.5 | Tip: Use the "SHIFT + RightClick feature" (s. /necb help) to disable single spells! '/necb save' stores your selection!
* Added new CheckBox to trigger PvP CastBars even if no target is selected! If enabled all PvP CastBars detected by your CombatLog will be displayed (too many ;-) )
* Added 'myAddOns' support (Thanks to justcallmefred for the hint)

* Added: All PvP Spells (e.g. gains) will have their bar deleted if there appears a 'fades' message in the combatlog. Before this version only DeBuffs/Afflictions were removed.

* Fixed not detecting RaidLeader's CTRA Channel Broadcasts with patch 1.11!

* Optimized the SHIFT+RightClick (Disable Spell) Feature
 + Now the origin of CoolDowns (CD) and Duration (D) Bars is detected.
 + If spell is already disabled a message appears
 + Manual timers (grey bars) are detected and a message appears

* Added AQ40 Yauj Great Heal
* Added (Warrior) "Mortal Strike" DeBuff ('Solo Debuffs' category) (Thanks to ZeroKnowledge for this idea)
* Added (Hunter) "Expose Weakness" DeBuff (DeBuff category + displayed for Hunters only!) (Thanks to Fedos for this idea)
* Reactivated (Warlock) spell "Inferno"
* Changed cooldown of "Ice Barrier" from 120 to 30 secs (Thanks to carpone)
* Removed "Lay on Hands" (Paladin) (Thanks to carpone)

* Rewritten some parts of the Raid-Spell section to allow a more flexible spell support via the changed functionality of the "mcheck" flag:
 + It's now possible to allow the same spell name used to be in Raid and PvP section simultaneously (if "mcheck" is used)!
 + Displays a CastBar if the mobname is a part(!) of the optional 'mcheck' flag. mcheck="Ragnaros - Princess Yauj" possible!

* Other minor fixes


28.06.06 Natur EnemyCastBar 4.5.0
-------------------------------------------------------------------
* New Feature: You may now customize the CastBar Colors! (Use new 'Colors' Button in menue.)
-------------------------------------------------------------------
+ After 14 hours of learning and programming this feature is done ;p
+ Because of the current way in which settings are stored, it won't be possible to share one color setting with other characters. (Copy them manually.)

* Added Naxxramas Anub'Rekhan "Locust Swarm" (Note: The 90 secs cooldown is assumed, in fact it is more or less (random factor!))
* Added AQ40 Yauj Fear (20 sec cooldown)
* Added (Mage) Spell "Polymorph: Pig", "Polymorph: Turtle" (linked DR) (Thanks to Danno for the 'turtle hint')
* Added (Mob) Spell "Black Sludge", "Toxic Bolt", "Poisonous Spit", "Wild Regeneration" (only CastTime not GainTime)

* Fixed: "/necb versions" no longer mixes up usernames after a broadcast when the raid has been changed
* Fixed: Broadcasted Spells won't trigger a CastBar anymore if NECB is disabled
* Fixed: DoT's CastBars won't be removed by "/necb stopcount ..." anylonger

* Disabled C'Thun support! Too many users are reporting wrong timers and I am not able to check this.
+ Maybe someone is able to check my timings/code and to fix some things since I have never been at C'Thun, yet. The code still exists in NECB.


20.06.06 Natur EnemyCastBar 4.4.0
* Improved the estimated time at the GCInfo window (/necb gcinfo). Now the time until purge is continously(!) calculated by using the last 30 seconds. This and the 'kb/s' are updated every 5 seconds. Memory usage and maxiumum is updated every 0.5 seconds.
* Improved: Completely rewritten "/necb versions"! Now the list is sorted by version number and additionally displays the User's names in a smart way. :D

* Updated TOC for patch 1.11


18.06.06 Natur EnemyCastBar 4.3.9a
* Added an estimated time to the GCInfo window until the GarbageCollector purges your wasted AddOn Memory (/necb gcinfo). Resets once a minute. Memory usage is updated every 0.5 seconds now.

* Fixed an error message at Huhuran! (Thanks to Lain for reporting this one)
* Fixed not working "Freezing Trap (Effect)" with english and french client (Thanks to Fedos!)


16.06.06 Natur EnemyCastBar 4.3.8 (slash commands renamed to '/necb' !)
-------------------------------------------------------------------
* Added C'Thun support. You have to target Eye of C'Thun when you engage to trigger the castbars (on Regen_Disabled).
-------------------------------------------------------------------
+ Use necb's broadcasting feature to sync this event with all players!!! MT/ Engager should be a sender!
+ I am not able to test this feature. It has all been done by theory thanks to CTRA Bossmods and AQWarner. Thanks to Stanz, too.

-------------------------------------------------------------------
* Added new slash commands: "/necb save", "/necb load", "/necb remove xyz" to save and load disabled spells by SHIFT + RightClick.
-------------------------------------------------------------------
+ "/necb remove xyz" will restore the particular disabled spell xyz.

* Added the capability of detecting certain instant casts and added a new database flag (RaidSpells, icast="true") for instant casts to avoid spell mirroring (Used for 'Twin Teleport').

-------------------------------------------------------------------
* Changed "/cecb" to /necb" and renamed the AddOn; Removed slash command list "/cenemycast"
-------------------------------------------------------------------
+ Some "CECB"s kept to be compatible with older versions! (E.g. Folder of NECB, Variables of NECB, many internal things)

-------------------------------------------------------------------
* Changed: The CoolDowns for Huhuran, Twin Emperors and the initial C'Thun timers won't be updated for at least 3 minutes after you engaged those bosses! (Thanks to Fendryl/ Vladinator for the hint.)
-------------------------------------------------------------------
+ Within 3 minutes after you pulled the encounter the 'engage algorithm' is locked to prevent faulty updates! This timer is renewed everytime a RaidSpell triggers a bar (e.g. "Twin Teleport" for Twins, or you feign death). So ensure this happens (via broadcasts).
+ To be on the safe side, no hunter should be a sender for these encounters until we know the algorithm works correctly (for feign death) ;-)
+ All broadcasters should have the latest version of NECB or they might screw the timers for all receiving raidmembers!

-------------------------------------------------------------------
* Changed Cooldowns (as follows):
-------------------------------------------------------------------
+ The limit for short cooldowns ("ONLY show short CDs") from 30 to 60 seconds.
+ CoolDowns now will be updated and not displayed in a new bar, if the same mob and spell triggers an already running CD again.
+ CoolDowns will now be deleted on mob's death, too, if "ONLY show short CDs" is enabled.

* Changed Spell "Healing Wave" (Shaman) from 3.0 to 2.5 secs. (Full invested talent points presumed.) (Thanks kamuiGT)

* Added MobSpell "Gust of Wind" (Dust Devil) ;-)

* Fixes: Twin Teleport (AQ40) cooldown should work now, since instant casts are detected by necb with this version. (Again the broadcasting feature might be helpful to sync this event for all who weren't in combatlog range.)
* Fixed: Repeating CastBars with a total time of 0 are deleted now.
* Fixed: Now "Wyvern Sting" will always trigger a CastBar with mob = "Huhuran" (and not the last player who was afflicted by this spell)
* Fixed: The Paypal button is working again :D (It seemed there was something broken with it.)


08.06.06 Natur 4.3.0 This one again has a BIG list of additions! Read'em all pls :D
-------------------------------------------------------------------
* New Feature No.1: Added CastBars to watch your DoTs (mostly Warlock/ Priest 'Curses')!
-------------------------------------------------------------------
+ Added (12) spells: "Rend" (Warrior), "Serpent Sting" (Hunter), "Shadow Word: Pain" - "Devouring Plague" - "Holy Fire" (Priest), "Curse of Agony" - "Corruption" - "Immolate" (Warlock), "Garrote" (Rogue), "Insect Swarm" - "Moonfire" (Druid), "Flame Shock" (Shaman)
+ These bars will be triggered by the first periodic damage the DoTs afflict to the mob! It is not necessary to target the mob while waiting for the castbar (, but you have to be in combatlog range.)
+ The castbars won't be renewed if you cast a pure DoT again before it fades off! So wait a sec and all should work right ;-) (A fade detection would also remove your castbar if the debuff of other players fades!)
+ DoTs with an initial damage like "Immolate" will UPDATE the castbar! You may spam those ones and the timings will be correct :D
+ Only the player who casted the DoT will see a castbar
+ If you accidently renewed a pure DoT (without initial damage) before the CastBar ended simply click the CastBar away right after your cast with SHIFT + LeftClick and the timer is correct again.
+ Added a checkbox to toggle this option on/off

-------------------------------------------------------------------
* New Feature No.2: Now your own Combopoints are taken into account for "Kidney Shot" and "Rupture"! (Thanks to kamuiGT for a first piece of idea/code)
-------------------------------------------------------------------
+ The duration will/can only be recalculated for ROGUES! All others will always see a presumed maximum duration.
(Remember: It is not possible to read out combopoints of other players. Every finishing move of yours will change upcoming Kidney Shot Bars (from other players) for 3 seconds.)
+ If you lose CPs CECB will assume you made a finishing move and will display a newly triggered "Kidney Shot" and "Rupture" with a recalculated duration for the next 3(!) seconds! (I know there are other events which clear your CPs^^)
(3 seconds and no shorter duration, because rupture mostly won't trigger a bar earlier than 2 seconds. +1 second buffer for worst case (bad latency, very late damage by dot.) After three seconds the full duration will be used again.)
+ Half the times your CPs are cleared AFTER the affliction event (Kidney Shot) has been fired. To catch this case every reset of your CPs within one second after 'Kidney Shot' has been fired will recalculate the duration based on your previous CPs!

-------------------------------------------------------------------
* New Feature No.3: Added an info box about the Garbage Collector! (Displays how much memory is used by your AddOns and how much memory is 'wasted' per second.)
-------------------------------------------------------------------
+ "/cecb gcinfo" triggers the CECB GC Info Box :D

-------------------------------------------------------------------
* New SpellFlags added! This allows to only trigger CastBars on certain events and at certain zones! (This is what many Bossmods look for.)
-------------------------------------------------------------------
+ Added new RaidSpell flag "checkevent" to bind spells to only trigger a castbar if these events were fired. (Example: checkevent="CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE - CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" )
+ Added new RaidSpell flag "aZone" to only allow this spell to trigger a CastBar in the specific (Main)Zone. (Not the minimap zone, but the big global Zone e.g. Stormwind, not Trade District! Example: aZone="Ahn'Qiraj")
+ Added new RaidSpell flag "checktarget" to force a target check for RaidSpells. This normally is not beeing checked.

* Added AQ40 Huhuran 5 Minutes Timer until berserk mode, 10 sec cooldown of her Frenzy. You have to target Huhuran when you engage to trigger the countdown. (Thanks to specr1 for this suggestion)
* Added AQ40 Huhuran "wyvern sting" cooldown (25 secs, feature has to be tested!). Wyvern sting uses the new spell flags "aZone" and "checkevent".
* Added "Kick - Silenced", "Riposte" and "Repentance" to 'Solo Debuffs' category. (Thanks to kamuiGT and FangShui for the hint)
* Added "Rip" (Druid), "Rupture" (Rogue) to 'DoTs' category.
* Added "Greater Polymorph" (BWL, Spellbinder) to 'Mob outs' category.
* Added "Greater Heal" Priest T2 proc Support (Thanks to Kali)

* Changed: "Frenzy" is flagged by new spell flag "checktarget" now

* Fixed: Hakkar 90 sec timer should work correctly now.(And added a little check to optimize cecb broadcasts for this event.)
* Fixed: "Mandokir's Gaze" (Zul'Gurub) won't trigger a 'casting bar', but an 'affliction bar' now
* Fixed: Cleaned up some dirty code in some parts of the menue algorithm. The menue now fades in/out and if you disable the addon the menue will still collapse. While the GUI is beeing displayed less CPU Time is consumed than with earlier versions :D
* Fixed: Changed the death pattern to remove all bars even if you gained exp or honor by this kill.
* Fixed: Added "CHAT_MSG_COMBAT_XP_GAIN" event to safely detect a mob's death. Sometimes this event is the only one if a mob dies that gives XP since "CHAT_MSG_COMBAT_HOSTILE_DEATH" won't be fired everytime then!
* Fixed: Changed the duration of Sartura's Whirlwind(AQ40) from 8 to 15 secs. (Thanks to specr1)
* Fixed: CastBars are now cleared if an Obsidian Destroyer dies. (Separate algorithm for this speciality.)
* Fixed: Outsourced the "died" algorithm to always check for CastBars to be deleted regardless of any Options set. (Not only if DeBuffs enabled anymore.)

Note to Feature No.2 (CPs): By using the above strategy most of the time only the CP dependend skills executed by yourself will be recalculated. If any other player uses Kidney Shot or Rupture the maximum possible duration is presumed out of your CP reset window. Without this algorithm your current CP state would always(!) result in recalculated Kidney Shots and Ruptures from other players (likely to happen in Raids).


01.06.06 Natur 4.1.0 (german client 100%, en 100%, fr 100%)
-------------------------------------------------------------------
* New Feature No.1: Added class specific Diminishing Return timers which are only displayed for the class that can use this spell. The DeBuff duration IS recalculated by this timer!
-------------------------------------------------------------------
 Learn more about Diminishing Returns here: http://wowvault.ign.com/View.php?view=PatchNotes.Detail&id=22#14
+ Supported spells: Polymorph (Mage; didn't add Frost Nova for some reasons), Freezing Trap (Hunter), Shackle Undead (Priest), Seduction (Warlock Succubus), Sap - Kidney Shot - Gouge - Blind (Rogue), Entangling Roots (Druid), Frost Shock (Shaman)
 Since all spells of this class only have DRs against Players, the DR timers will only be triggered if your target is a Player!
 (Exception: Kidney Shot also triggers a DR Timer on mobs (and always presumes full combopoints)! If I made any mistakes or missed something, tell me if you are sure you tested it properly^^)
+ Support for Gauge and Sap sharing one DR Timer
+ Added a separate checkbox to trigger the new feature.
+ Learned more about Diminishing Returns! Now many DR Timers should be far more accurate!
 (Re'Sap', Re'Polymorph' etc. won't be detected because of missing combatlog messages for renewed debuffs! So the timers aren't accurate then!)
  Only Class specific skills (Polymorph, Sap) will have their DR Timer be corrected if they fade earlier. For the big stun-family a prediction is used, since those stuns should never fade earlier.
+ No DR Timer depends on enabled 'solo debuffs' anymore!
(Thanks to Azonia for keeping me busy on adding those DR Timers *g*)

-------------------------------------------------------------------
* New Feature No.2: Added Icons to the left of the CastBars! (200 Icons * 3 languages added manually :D) (Thanks to Iceroth for this suggestion)
-------------------------------------------------------------------
+ The Iconsize automatically fits to the formerly known 'Space between CastBars' setting.
 (Thanks to http://wowguru.com ! This site saved me alot of time searching for the right textures!)
+ Added a separate checkbox to trigger this feature.

-------------------------------------------------------------------
* New Feature No.3: The CastBars will now be pulled together if there is one bar deleted between others. Only if the CastBar above the space lasts longer than 5 seconds the bars will be moved. (Thanks to Nyce for this suggestion.)
-------------------------------------------------------------------

* Capable of detecting stackable spells now (e.g 'Sunder Armor').
* Added stackable spells: "Winter's Chill" (patch 1.11), "Fire Vulnerability" (patch 1.11), "Shadow Vulnerability" and renamed "Show mages cold effects" to "Show Cold + Vulnerability effects"

* Added "Improved Concussive Shot" (Hunter) to 'solo debuffs'
* Added "Frost Shock" (Shaman) to 'show cold effects'
* Added more poisons to be detected if performed on weapons (Rogue)
* Added "Shield Block" gain (Warrior). One talent point assumed (t=5.5) and deleted automatically if effect fades earlier!

* Fixed Hakkar for all clients! Especially german and french ones were bugged and should work perfectly now :D (Finally I learned how to use patterns correctly. Also needed to support periodic DeBuffs.)
* Fixed the german 'perform'-pattern! The wrong translation for any 'performs' seemed to exist very long and is fixed (for german client) now.
* 'Shift + RightClick' now displays a notice if the spell was not found in the database. Only the primary castbars of a spell will disable the spell.
* Fixed some PvP Spells (Changed casttimes, fixed names, removed CD...) and removed all spells which don't work (those were commented out before)
* Fixed: The 'Spell - Mob' order was broken in some cases
* Fixed: Dramatically reduced the memory eaten up by an opened menue! (Thanks to feyded for pointing this out :D ) Two local definition had to be changed to normal definitions and were outsourced.


26.05.06 Natur 3.8.5 (german client 100%, en 100%, fr 100%)
* "/cecb parser" now buffers 100 lines of messages. They can be scrolled by the buttons at the top right. I tried to make it work like the default chatframe :D
 Lines which have a StringWidth that is too long to fit into the parser frame will have their characters reduced until they are short enough.
 Adds a grey (C) behind the sender's name now, if it was a message from a client which uses a different language

* If the user is not in a raid no broadcasts will be sent anymore

* "Mob Outs" (Polymorph, Sap...) are now capable of triggering multiple bars if casted on differently named mobs (, otherwise the bar will just be updated.)

* Zul'Gurub: Added Mandokir's "Threatening Gaze" cast and debuff
* AQ40: Added cooldown until the Twin Emperors enter Berserk Mode (15 min). You have to target one of the twins when you enter combat (pull) to trigger the countdown. (Thanks to Kukulkan for this suggestion)
* AQ40: Death of "Obsidian Eradicator" triggers a (30 min) cooldown and added some code to prevent an update of this castbar
* AQ40: Reactivated "Explode Bug", "Mutate Bug" and added french translation
* AQ40: Added Anubisath Defenders "Plague"
* AQ40: Added Fankriss the Unyielding's "Entangle"

* Fixed: The Diminishing Return feature should work almost correctly now.
 (Remember that switching targets and multiple mobs with the same name may reset the DR Timer!)
* Zul'Gurub: Fixed "Illusions of Jin'do" for german client! A change of the pattern strings was necessary because of a word ("von") in the german spell name which collided with the german search pattern.
* BWL: Fixed "Burning Adrenaline", "Frenzy" and Razorgore start detect for french client.
* Fixed: Removed the solo-flag from "Frostbolt" for german clients. DeBuff Should be triggered now if only "Show Mages cold effects" is enabled.
* Fixed: "Entangling Roots" is flagged to be a "mob out" again, but now the bar is removed if the afflicted mob dies


19.05.06 Natur 3.7.7 (german client 100%, en 100%, fr 99%)
* The automatic broadcasting feature now prevents that castbars triggered by your own combatlog are just updated from the first broadcast of another player!
* "/cecb parser" now displays a "(S)" behind the name of the sender which triggered a CastBar for you :D Unnecessary broadcasts have a yellow "(number)" behind the broadcaster's name. Just to have some more info ^^

* The setting "Broadcast CBs via CT_RA Channel" will be saved now! (Remember to only ask selected people to broadcast CastBars!)

* Fixed french spells which used a "/" instead of a "\" for special characters (Thanks to Faerian again)
* Fixed "HaRNstring" to "HaMstring" ;-) (Thanks to N00bZXI again)


18.05.06 Natur 3.7.5 (german client 100%, en 100%, fr 99%)
WARNING: Due to changes of the SendMessage routine, version 3.5.3 is NOT ABLE TO READ the automatically broadcasted messages of this version! (see 'drunken protection')
--------
-------------------------------------------------------------------
* New Feature: With SHIFT + Right(!)Click you now disable the specific spell for the rest of your wow session (until you logout or reload your UI)
------------------------------------------------------------------- 
+ "/cecb disabled" will list all disabled spells
+ "/cecb restore" will restore all spells disabled by SHIFT + RightClick
 (Remember to use the "Help" Button or to type "/cecb help" for a list of all commands.)

-------------------------------------------------------------------
* New Feature: Added castbar for stuns' diminishing return (20 sec timer)! Depends on enabled 'Solo Debuffs'. (Thanks to Azonia for this suggestion!)
-------------------------------------------------------------------
+ There are 8 known skills (3 Warrior, 3 Druid, 1 Pala and 1 Rogue skills) which use the same diminishing return timer in pve. Only these will trigger a bar.

* Added 'Cause Insanity' to Raid DeBuffs (Hakkar and other Bosses)
* Added CastBar for first time until life drain of Hakkar (after Boss pull)

* Moved Mages 'Frost Nova', 'Frostbite', 'Chilled', 'Cone of Cold' and 'Frostbolt' to the new section 'Mages Cold DeBuffs'!
* Added new checkbox to trigger 'Mages Cold DeBuffs' separately

* Added a minimap button (movable/ hideable)

* Added a 'drunken player' protection to the automated broadcasting system. (All 's' and 'S' will be changed into symbols to trick 'drunken messages'.)
 Now CECB uses the same algorithm CTRA uses to transcode messages before they are sent and received! (Thanks to Stanz for his hint!)
        
* Translated almost EVERY french skill! (Many, many thanks to Faerian for his superb work!)

* Added cooldowns to all trinkets & racials (and fixed casttimes, names in some cases) (Thanks to thottbot.com ;-) )
* Added Priest Talent gain 'Focused Casting'
* Changed casting time of 'Greater Heal', 'Smite' and 'Inner Fire' to match the full skilled talent 'Divine Fury' (Thanks to ciferfromger)
* Changed the positions of some Checkboxes a little bit
* Doubled the lines of the CECB CTRA Channel Parser (20 now)
* Fixed Mages 'Chilled' for engl. clients (Thanks to ciferfromger)
* Fixed Flamegor Frenzy Cooldown for engl. client! (Thanks to Quiksmage for the hint.)
* Fixed the tooltip of some sliders for english and french clients
* Fixed that the position of the free FPS bar will be also be restored after the addon has been set to default values
* Fixed spell mirroring with Onys/ Vaelastrasz 'Flame Breath'
* Added one second to 'Cone of Cold' affliction to consider a slight talent investment and to be consistent with the slight improvement to Frostbolt's cold effect of older versions.
* Added Mob spell 'Spirit Decay'
* Updated CT_RA_Readme.txt with a short description for ".cecbspell MobName, SpellName, Type, ClientLang, Latency"


13.05.06 Natur 3.5.3 (german client 100%, en 100%, fr 80%)
* Fixed: Forgot to uncomment some lines in the broadcast routine :/


12.05.06 Natur 3.5.2 (german client 100%, en 100%, fr 80%)
-------------------------------------------------------------------
* Added automatic RaidSpell broadcasting through CT RaidAssist channel!
-------------------------------------------------------------------
Some words to the broadcasting feature:
# Broadcasting is only allowed if you joined a valid CT_RA Channel (through CT_RA channel broadcast). Broadcasting will be set to disabled after a relogin. (The channel is saved.)
# Only Raidspells and -Debuffs plus Debuffs like "Polymorph" and their fade plus the mobs death (if needed) will be broadcasted.
# I suggest that only a handful people broadcast the spells to keep channel traffic as low as possible: The MT, a healer and the raidleader. So hopefully a big radius of combatlog messages is catched.
# Users with a latency more than 500ms won't broadcast to not delay the timer too much.
# The taunt MTs for Firemaw might want to disable this function periodically to achieve the highest accuracy for this encounter.
# You have to turn these specific spell categories on to broadcast the above spell categories.
# To reduce broadcast traffic the same broadcast won't be directly repeated within a short peroid of time (< 5 seconds)! (Same with received packets.)
# If sender and receiver have a client of different language then broadcasts won't be accepted
Although I tried my best to add a feature like this, expect no wonders and don't fear strange castbar behaviors! Otherwise don't use it ;-)

* Settings will be saved per character now! (Not one setting for all characters anymore.)

* Added a new slashcommand "/cecb versions" to print a version statistic after a CT_RA Broadcast.
Your channelparsing has to be enabled to detect the version of other users. Other users won't send their version without an enabled channelparsing, either!
This feature lets you know how many people will receive your CECB Broadcasts! (Only versions after 3.0.6 are ready for CT_RA channelparsing)
* Added a new slashcommand "/cecb parser" which opens the 'CECB - CTRA Channel parser'. The parser displays the last 10 CECB Commands found in the CT_RA Channel.

* Added a new slider to set the space between the CastBars! (Thanks to N00bZXI for this suggestion!)

* Added a new Debuff category: 'Solo Debuffs'! (Thanks to Apok, Showdown, dgwow for their call to add this *g*)
 Spells of this category are:
 * Warrior 'Shield Bash - Silenced', 'Concussion Blow', 'Revenge Stun', 'Charge Stun', 'Intercept Stun', 'Intimidating Shout', 'Disarm'
 * Mage 'Counterspell - Silenced', 'Frostbolt' (This one is especially for cncfanatics ^^)
 * Rogue 'Cheap Shot', 'Gouge', 'Blind', 'Kidney Shot'
 * Druid 'Bash', 'Pounce', 'Feral Charge Effect'
 * Priest 'Psychic Scream'
 * Warlock 'Fear'
 * Paladin 'Hammer of Justice' (first Paladin Debuff in database *g*)
* Added an option to enable 'Solo Debuffs' (disabled by default)

* Added AQ40 Skeram 'True Fulfillment', 'Arcane Explosion', (Skeram's images won't be supported)
* Added AQ40 Sartura 'Whirlwind', 10 Minutes Timer until enraged mode

* Added Trinkets/Talents 'Earthstrike', 'Gift of Life', 'Power Infusion' (Priest Talent), 'Nature Aligned', 'Stormstrike' (Shaman Talent) (Thanks to Azonia for info)
* Added 'mob out': Seduction (Warlock, Succubus)

* "You/you" will be changed to the players name for broadcast reasons and to detect more fades
* If the player was the target the Castbar's label will be printed with a red shadow

* Fixed Nefarian Warlock call for german client (now really :D)
* Changed the time until mobspawn to 45 sec for Razorgore encounter
* Fixed a menue display problem (very transparent options)


04.05.06 Natur 3.0.6 (german client 100%, en 100%, fr 85%)
Revised the 'grey bars' as follows:
* Added optional CT_RA support! The channel broadcast is detected and the CT_RA channel will be parsed for CECB .commands (s. below, CT_RA_readme.txt in CECB folder)! (Thanks to Stanz for this idea.)
(Through this you are able to trigger bars at all CT_RA raidmembers screens in a silent way! The CT_RA (Bossmods) coders are able to control grey bars by software/events.)
* Important!: Added a unique check for the channel .commands and the equivalent slash commands, so that only one bar with the same SPELL (first part of the label) is shown at once. If one grey bar with the same name is active it will be updated/restartet!
* Added "/cecb stopcount label" - Stops all grey CastBars which inherit the text 'label'. "/cecb stopcount all" deletes all grey CastBars!
* Added the feature to change the label of countmin, countsec and repeat. E.g. "/cecb countsec 10 time until spawn" will create a 10 sec countdown with the label "time until spawn - (10 Seconds)"

* Added BossGain 'Frenzy' (in addition to the cooldown triggered by the bosses' emote) and detects if this buff is removed!
* Added Talent gains 'Vengeance' (Paladin), 'Inspiration' (Target of Priest)
* Druids 'Entangling Roots' 'fragile-flag' has been removed, so this Bar is deleted if the Mob dies.
* Adjusted 'Frenzy' to 8 seconds duration

* Fixed Nefarian Rogue and Warlock calls for german clients. (The search strings didn't seem to be correct.)
* Fixed chromaggus frenzy (removed wrong flag and corrected german trigger-string)

* Outsourced the routine which fades or removes spells to always check those events (and not only if the 'Debuffs' checkbox is enabled)


29.04.06 Natur 2.8.8 (german client 100%, en 100%, fr 85%)
* New Feature: CastBars with a total time >= 20 seconds will Flash if they reached the last 20% AND their time left is smaller than 10 seconds. (Thanks to Ameline for this suggestion!)
* Added Checkbox to enable 'global Mob outs'. If this one is enabled 'Mob outs' (which are 'Polymorph', 'Shackle Undead' etc.) will trigger a castbar even if the affected mob is NOT your current target. (Enabled by default)
* Added Chechbox for the 'Flash' Feature (Enabled by default)
* All Fading/ Flashing of CastBars and the collapse animation of the options frame are FPS independent until the framerate drops below 5(fps).
* Added a FPS meter to the options menue (just for the fun of it: green = good, yellow = could be better, red = you have hard times)
(A checkbox near the FPS Bar spawns a movable dublication!)

* Added Priest gain 'Feedback'; debuff 'Mind Soothe'
* Added Rouge debuff 'Crippling Poison'; gains 'Vanish' (+CD), 'Blade Flurry' (+CD)
* Added Druid debuffs 'Challenging Roar', 'Growl'; gain 'Barkskin' corrected (+CD)
* Added Warrior debuff 'Challenging Shout'; gains 'Last Stand' (+CD), Death Wish (+CD); removed CD of 'Bloodthirst'
* Added Hunter debuff 'Wing Clip'; gain 'Deterrence'
* Added Mage gain 'Arcane Power' (+CD); Reenabled Mage teleport spells
* Added Warlock gain 'Amplify Curse' (+CD)
* Added Trinket 'Mar'li's Brain Boost' (+CD)
* Changed the time until mobspawn at Razorgore encounter to 50 sec
* Added Ebonroc to presume wingbuffet. (You just have to target Ebonroc at pull to trigger a CastBar.)

* Changed the layout of the Options frame. (The height got too large to add more buttons.)


22.04.06 Natur 2.6.0 (german client 100%, en 100%, fr 85%)
* New Feature: You may now trigger CastBars on your Party/RaidMembers screens. Those have to toggle the feature on and receive your input via ".countmin", ".countsec" or ".repeat". (Thanks to Elp for this suggestion!)
* At Firemaw and Flamegor the first(!) wingbuffet is presumed now! You have to target those bosses at pull to trigger a castbar.
* Added new Checkbox to disable CastBars for 'gains' (like HoTs or 'Blink') separately. Some Healers might love it. (Thanks to ThaNaGui for this suggestion!)
* Added new Checkbox to flip over the CastBars' order. (Thanks to Esper for this suggestion!)
* Added new Checkbox to lower the fontsize of the Castbars' text. More letters may be displayed in one CastBar through this setting.
* Added ToolTips

* The options menue collapses and all options fade off if you disable the AddOn. (Try it :D )
* The checkbox of dependent features will now be disabled instead of beeing unchecked (if their parent is switched off)

* Nefarian's Class Call now displays the chosen class (and bar color changed to "gains")
* The timing of the wingbuffet is a little more exact now. (Intervall: 31.5s, cast-time: 1.2s). Remember that some circumstances may delay the wingbuffet for a short time (around 1 - 2 seconds).
* Translated all needed patterns for the french client (beta-test "Debuffs" and "Fades"). (Thanks to ThaNaGui for his help!)

* Removed "/cecb status"
* Removed Debug checkbox and disabled this mode
* Fixed an error which in some cases appeared after "countmin", "countsec" or "repeat" have been used 'incorrectly'
* Some design changes and modified/ disabled messages
* Changed nomenclature of upcoming version numbers (previous version was Natur 2.1.8 (2.18))


16.04.06 Natur 2.18 (german client 100%, en 100%, fr 70%) - official final release!
* Added/ Unlocked the cooldown for some spells (ideal for PvP). (Only 'casting' spells and 'gains' work, e.g.: "Xyz begins to cast spell".)
* Added an option to toggle 'Cooldowns'. (Dependent on 'PvP/Common spells' checkbox)
* Additional to "/cecb show" you may now use a new button in the options menue.
* While "/cecb show" only one bar will be possible to avoid a broken castbar frame. (The system is locked then.)
* Now the alphasetting is applied to the complete Castbar
* The CastBars don't popup instantly anymore, they have a soft alpha fade in now
* Redesigned GUI to match the games one
* The Addon unregisters all Events if it is disabled or if the user gets a loading screen to minimize CPU load! (Btw. more parsing mods should do this^^)

* Added a slider to chose how many CastBars are displayed at once (from 5 to 20 selectable)
* Added an option to toggle 'Afflicitions' (Debuffs)
* Added an option to only show 'Afflicitions' (Debuffs) for Raidencounters
* Bars from 'Afflictions' (Debuffs) are cleared if your target dies or the Debuff fades off.
(Remember: Most features only work if you are in combat-log range!)
* Finally it is done that while selecting the scale of the CastBars the Bars are zoomed from their exact middle and stay fixed into position

* Raid 'afflictions' (debuffs) will have their label turned around: "mob - spell" instead of "spell - mob"
* PvE/Raid Spells and all (Spell)Debuffs now always have a unique bar to prevent spamming your screen. Only a few RaidDebuffs may produce multiple bars.

* Added (first) RaidDebuffs: Razorgores (and Drakkisaths) Burning, Vaelastrasz BA, Shadow of Ebonroc, Baron Geddon's Living Bomb, Delusions of Jin'do
* Added raid 'gains': Baron Geddon's Inferno, Moam's Energize (and its removal)
* Added raid countdown: Razorgore - 1 min until Mobspawn, Moam - 90 sec until Stoneform
* Added more 'Afflictions' (Debuffs): "Shackle Undead", "Polymorph", "Banish", "Freezing Trap", "Sap", "Entangling Roots", "Hibernate"
(to see how long the Mob is afflicted (max. time presumed!))
* Added MobSpells: "Shadow Bolt Volley", "Dark Mending", "Cripple", "Banshee Curse", "Shrink"

* Removed "/cecb show" - use the options menue instead
* Removed "/cecb buffet" - use "/cecb countsec 30" instead

* Recognizing healing casts of mobs and friendly players death now
* Added two new string-patterns to recognize fading debuffs. (French needs some translation! Only 'fades' but no 'breaks' ('is removed') pattern ready.)
* Added a special spellcheck code for the german client to capture spells in apostrophes correctly, (although they are without them in the spell database!)
* Added a new section in localization.lua for 'Afflicitions' (Debuffs) to be independent from Raid and PvP settings

* Added additional checks to 'PvE/Raid' and 'Affliction' spells to prevent faulty popups and updates
* Added a Mobcheck for spells which are both cast from RaidMobs and from Players. Only the specific RaidMob will trigger a castbar. (Use "mcheck" in database.)
* PvP Spell 'gains' now will automatically have the c="gains" (see spell database) flag applied. (No need for this flag in language.lua in the PvP section anymore.)
* Fixed a bug with 'Majordomo' which always appeared if two bars are generated through one spell
* Some runtime optimizations
* Fixed some other minor bugs
- final release after 100+ hours of pure work and understanding WoW Mods, .lua, .xml and the API


31.03.06 Natur 2.01
* Added the ability to target the player/mob from left clicking the bars (thanks Astalia, Limited)
(Always the nearest Mob with the same name will be target!)
* Added options to disable the "target on BarLeftClick" feature
* Added a confirmation box if the the user hits the "Reset to defaults" button
* Fixed: Invisible Bars aren't left on screen anymore
* Added (Mob) "Schattenblitz-Salve", "Dunkle Besserung" (engl. missing) (and new Eventcheck with it)
* MobAfflictions and common Spells now may have an unique status to prevent bars spamming your screen
- unreleased, internal testing only

30.03.06 Natur 2.0
* EnemyCastBar now has an options window (GUI)! (use "/cecb" to toggle it)

* The new GUI allows you to reset the addon completely to default values.
* Alpha and Scale settings will now popup an example bar through the GUI.

* Changed the way afflictions are handled. Mobs should never mirror your cast now.
* Added the ability to hide an active bar by SHIFT + left clicking it (thanks Limited)
* Added the ability to clear all bars at once by ALT + left clicking it
* The bars now are presented with a transparent black background
* "/cecb show" now automtically toggles the CastBar lock if the bars are locked
* Added "/cecb status" to receive a quick status overview
* Spells afflicting a Mob now may be toggled on and off
(This feature enabled might pop up many bars in some cases!)
* Added (Warrior) "Taunt", "Mocking Blow" afflictions (and new Eventcheck with it)
- unreleased, internal testing only


29.03.06 Natur 1.5bh
* Corrected an error in german translation causing castbars not appearing at boss encounters in MC
* Added (Mage) "Frost nova", "Frostbite", "Chill", "Cone of cold" afflictions
* Added new check for spells afflicting mobs/players and fading off so that bars are disappearing when the effect is over
* Added new check whether a spell is also able to afflict the target - this prevents mobs from popping up castbars for spells YOU casted
(If you have trouble with more spells which behave like mentioned above then let me know - I will try to fix those as well! (Spellname?)
* Updated TOC for Patch 1.10


28.03.06 Natur 1.5bg
* Lockstatus now shown in help
* Alpha blending, scaling and repeater added - "/cecb help" for more info
* Time input check and imput time printed to the castbar label


27.03.06 Natur 1.5bf
* "unique bar" updater - boss encounters always should exactly bring up one castbar per event


23.03.06 - 24.03.06 Natur 1_5bb - Natur 1_5be
* Slashcommands added - "/cecb help" for more info


15.03.06 Natur 1.5ba
* Some corrected german translations